/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * AlgoLogo.java
 * JDK 1.1 
 * Version 1.1 Rvision 30/12/1999
 * Applet permettant d'excuter un programme minilogo 
 * en mode texte.
 * Paramtres du tag Applet :
 * NAME fichier VALUE "nom_du_fichier"
 * NAME logoprog VALUE "un programme"
 *
 */

import java.util.Vector;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import jkb.calkul.*;
import jkb.mlogo.*;
import jkb.utils.FileStr;

public class AlgoLogo extends Applet 
 implements ActionListener,KeyListener {
 TextArea zoneRep;
 TextArea zoneEdit;
 Label infoLabel;
 LogoExe mlogo;
 Button b_exec;
 Button b_efface;
 
 public void init() {
  Panel pan,pan2;
  Label lab;
  setLayout(new BorderLayout());
  pan=new Panel();
  pan.setLayout(new GridLayout(1,2));
  zoneEdit = new TextArea();
  zoneEdit.addKeyListener(this);
  pan.add(zoneEdit);
  zoneRep = new TextArea();
  zoneRep.setEditable(false);
  zoneRep.setBackground(new Color(200,200,200));
  mlogo=new LogoExe();
  mlogo.defZoneTexte(zoneRep);
  pan.add(zoneRep);
  add("Center",pan);
  pan=new Panel();
  pan.setLayout(new GridLayout(1,2));
  pan.setBackground(new Color(192,192,192));
  pan2=new Panel();
  pan2.setLayout(new FlowLayout(FlowLayout.LEFT));
  pan2.setBackground(new Color(192,192,192));
  b_exec=new Button("Excuter");
  b_exec.addActionListener(this);
  b_efface=new Button("Effacer");
  b_efface.addActionListener(this);
  pan2.add(b_exec);
  pan2.add(b_efface);
  pan.add(pan2);
  infoLabel=new Label(LogoExe.MLogoVersion);
  infoLabel.setBackground(new Color(192,192,192));
  pan.add(infoLabel);  
  add("South",pan);
 }
 
 void message(String S) {
  infoLabel.setText(S);
 } 
 
 public void start() {
  String comstr;
  comstr=getParameter("logoprog");
  if (comstr!=null && comstr.length()>0) zoneEdit.setText(comstr);
  comstr=getParameter("fichier");
  if (comstr!=null && comstr.length()>0) {
   try {
    URL source = new URL(getCodeBase(), comstr);
    String script=FileStr.lireChaineFichier(source);
    if (script!=null) zoneEdit.setText(script);
    else message("Lecture fichier impossible.");
   }
   catch(Exception e) {
    message("URL incorrecte.");
   }
  } 
  zoneEdit.requestFocus();
 }

 public String getAppletInfo() {
  return(LogoExe.MLogoVersion);
 }

 public void execute() {
  LogoStr LS=new LogoStr(zoneEdit.getText());
  Vector prog=LS.compile(mlogo.dico);
  if (LS.codeErreur==0) mlogo.execProg(prog,true);
  message(LS.messageErreur());
 }
 
 public void actionPerformed(ActionEvent evt) {
  if (evt.getSource()==b_exec) execute();
  else if (evt.getSource()==b_efface) {
   zoneEdit.setText("");
   zoneRep.setText("");
   message(LogoExe.MLogoVersion);
   zoneEdit.requestFocus();
  }
 }
 
 public void keyPressed(KeyEvent evt) {
  if (evt.getKeyCode()==KeyEvent.VK_F9) execute();
 }
 
 public void keyTyped(KeyEvent evt) {
 }
 
 public void keyReleased(KeyEvent evt) {
 }

}

