/*
 * Copyright (c) 2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * FeuilleDeCalcul.java
 * JDK 1.1  
 * Version 1.1 Rvision 17/06/2000
 * Applet dfinissant une feuille de calcul
 *
 */

import java.util.Hashtable;
import java.util.StringTokenizer;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import jkb.utils.Div;
import jkb.calkul.*;

public class FeuilleDeCalcul extends Applet 
 implements KeyListener {  
 public int modeEquation=0;
 public int modeEval=0;
 public Hashtable dico;
 public TextField zoneTexte=new TextField(40);
 public TextArea zoneInfo=new TextArea();
 public int modeAngle=MathNode.mDegre;
 
 public void init() {
  setBackground(Color.lightGray);
  dico=new Hashtable();
  MathNode.initDico(dico);
  MathNode.defVar("REP",0.0,dico);
  String S=getParameter("radian");
  if (S!=null) {
   if (S.equals("oui")) modeAngle=MathNode.mRadian;
  } 
  S=getParameter("mode");
  if (S!=null) {
   if (S.equals("equation")) modeEquation=1;
  }
  S=getParameter("typexp");
  if (S!=null) {
   if (S.equals("simple")) modeEval=1;
  }
  setLayout(new BorderLayout());
  zoneInfo.setEditable(false);
  zoneTexte.addKeyListener(this);
  zoneTexte.setBackground(Color.white);
  zoneInfo.setBackground(Color.white);
  add("North",zoneTexte);
  add("Center",zoneInfo);
 }

 String prepare(String S) {
  String f="";
  char c;
  char d='+';
  String ch=S;
  if (modeEval==0) return S;
  //supprimer les espaces 
  while (ch.indexOf(" ")>=0) ch=ch.replaceAll(" ","");
  //remplacer crochets
  while (ch.indexOf("[")>=0) ch=ch.replace('[','(');
  while (ch.indexOf("]")>=0) ch=ch.replace(']',')');
  //rtablir les multiplications
  for (int i=0; i<ch.length(); i++) {
   c=ch.charAt(i);
   if ("xyz".indexOf(c)>=0 && "(+-/*=".indexOf(d)<0 ) 
    f=f+"*"+c;
   else if (c=='(' && "(+-/*=".indexOf(d)<0 )   
    f=f+"*(";
   else f+=c;
   d=c;
  }
 //supprimer les carrs
 while (f.indexOf('')>=0) f=f.replaceAll("","^2");
 return f;
}

 String execDans(String com) {
  String tmp1,tmp2;
  String rep="";
  StringTokenizer t=new StringTokenizer(com," ");
  //lire "dans"
  tmp1=t.nextToken();
  //lire le nom
  tmp1=t.nextToken();
  //lire la formule
  tmp2=t.nextToken();
  double d=EvalStr.eval(prepare(tmp2),dico,modeAngle);
  if (!Div.errCalc(d)) {
   MathNode.defVar(tmp1,d,dico);
   rep=tmp1+" = "+Div.DoubleToStr(d,8);
  }
  else rep=tmp1+" : "+EvalStr.evalStr(prepare(tmp2),dico,modeAngle);
  return rep;
 }

 public String exec(String com) {
  String rep="";
  if (com.indexOf('=')>=0 || com.indexOf('>')>=0 || com.indexOf('<')>=0) {
   rep = com+"  "+EvalStr.evalBool(prepare(com),dico,modeAngle);
  }
  else {
   if (modeEquation==1) rep="Il faut crire une galit !";
   else {
   if (com.startsWith("dans ")) rep=rep+execDans(com);
   else {
    double d=EvalStr.eval(prepare(com),dico,modeAngle);
    if (!Div.errCalc(d)) {
     MathNode.defVar("REP",d,dico);
     rep=com+" = "+Div.DoubleToStr(d,8);
     }
    else rep=com+" : "+EvalStr.evalStr(prepare(com),dico,modeAngle);
    }
   }
  } 
  return rep;
 }
 
 public Insets getInsets() {
  return new Insets(2,2,2,2);
 }

 public void start() {
  zoneTexte.requestFocus();
 } 
  
 public void keyPressed(KeyEvent evt) {
  if (evt.getKeyCode()==KeyEvent.VK_ENTER) {
  String S=exec(zoneTexte.getText());
  zoneInfo.insert(S+'\n',0);
  }
 }
 
 public void keyTyped(KeyEvent evt) {
 }
 
 public void keyReleased(KeyEvent evt) {
  if (evt.getKeyCode()==KeyEvent.VK_ENTER) zoneTexte.selectAll();
 }
 
 public void vider() {
  zoneTexte.setText("");
  zoneInfo.setText("");
  zoneTexte.requestFocus();
 } 

 public void setvar(String S, double d) {
  MathNode.defVar(S,d,dico);
 }

}

