/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * FigLogo2d.java
 * JDK 1.1 
 * Version 1.1 Rvision 30/12/1999
 * Applet permettant d'afficher un dessin dfini par un programme minilogo. 
 * Paramtres du tag Applet :
 * NAME fichier VALUE "nom_du_fichier"
 * NAME logoprog VALUE "un programme"
 * NAME un VALUE "nombre de pixels par unit"
 *  la valeur par dfaut est 20 
 *
 */

import java.util.Vector;
import java.util.Hashtable;
import java.net.URL;
import java.applet.Applet;
import java.awt.*;
import java.awt.Color;
import jkb.geom.Plan;
import jkb.mlogo.*;
import jkb.utils.FileStr;
import jkb.calkul.*;

public class FigLogo2d extends Applet {
 Plan zoneDessin;
 Logo2d tortue;
 String progStr;
 
 public void init() {
  zoneDessin=new Plan();
  setLayout(new BorderLayout());
  add("Center",zoneDessin);
  tortue=new Logo2d(zoneDessin);
  progStr=null;
 }
 
 public void start() {
  String comstr;
  comstr=getParameter("un");
  if (comstr!=null && comstr!="") {
   Double u=new Double(comstr);
   if (!u.isNaN()) {
    zoneDessin.fenetreOrthoCentre(u.doubleValue());
    MathNode.defVar("XMIN",zoneDessin.xMin(),tortue.dico);
    MathNode.defVar("XMAX",zoneDessin.xMax(),tortue.dico);
    MathNode.defVar("YMIN",zoneDessin.yMin(),tortue.dico);
    MathNode.defVar("YMAX",zoneDessin.yMax(),tortue.dico);
   }
  } 
  comstr=getParameter("logoprog");
  if (comstr!=null && comstr.length()>0) progStr=comstr;
  if (progStr!=null) dessineFigure();
  comstr=getParameter("fichier");
  if (comstr!=null && comstr!="") lireFichier(comstr);
 }

 public void exec(String S) {
  progStr=S;
  dessineFigure();
 }
 
 void dessineFigure() {
  if (progStr!=null && progStr.length()>0) {
   LogoStr MS=new LogoStr(progStr);
   Vector prog=MS.compile(tortue.dico);
   if (MS.codeErreur==0) {
    tortue.execProg(prog,true);
   }
   else showStatus(MS.messageErreur());
  }
  zoneDessin.repaint();
 }

 public void lireFichier(String nom) {
  try {
   URL source = new URL(getCodeBase(), nom);
   progStr = FileStr.lireChaineFichier(source);
  }
  catch(Exception e) {
   showStatus("URL inaccessible.");
  }
  if (progStr==null) showStatus("Lecture du fichier impossible.");
  else dessineFigure();
 }

 
}

