/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * FigLogo3d.java
 * JDK 1.1 
 * Version 1.1 Rvision 30/12/1999
 * Applet permettant d'afficher un dessin dfini par un programme minilogo. 
 * Paramtres du tag Applet :
 * NAME fichier VALUE "nom_du_fichier"
 * NAME logoprog VALUE "un programme"
 * NAME echelle VALUE "nombre"
 *  la valeur par dfaut est 1 
 *
 */

import java.util.Vector;
import java.util.Hashtable;
import java.net.URL;
import java.applet.Applet;
import java.awt.*;
import java.awt.Color;
import jkb.geo3d.Espace;
import jkb.mlogo.*;
import jkb.utils.FileStr;
import jkb.calkul.*;

public class FigLogo3d extends Applet {
    Espace zoneDessin;
    Logo3d tortue;
    String progStr;
 
    public void init() {
	zoneDessin=new Espace();
	setLayout(new BorderLayout());
	add("Center",zoneDessin);
	tortue=new Logo3d(zoneDessin);
	progStr=null;
    }
 
    public void start() {
	zoneDessin.R.recadre(getSize().width,getSize().height);
	zoneDessin.img=createImage(zoneDessin.R.largeur, zoneDessin.R.hauteur);
	String comstr;
	comstr=getParameter("echelle");
	if (comstr!=null && comstr!="") {
	    Double u=new Double(comstr);
	    if (!u.isNaN()) zoneDessin.R.fixeEchelle(u.doubleValue());
	}
	comstr=getParameter("logoprog");
	if (comstr!=null && comstr.length()>0) {
	    progStr=comstr;
	    dessineFigure();
	}
	comstr=getParameter("fichier");
	if (comstr!=null && comstr!="") lireFichier(comstr);
    }

    public void exec(String S) {
	progStr=S;
	dessineFigure();
    }
 
    void dessineFigure() {
	/**
	if (progStr!=null && progStr.length()>0) {
	    LogoStr MS=new LogoStr(progStr);
	    Vector prog=MS.compile(tortue.dico);
	    if (MS.codeErreur==0) {
		tortue.execProg(prog,true);
	    }
	    else showStatus(MS.messageErreur());
	}
	**/
	if (progStr!=null && progStr.length()>0) tortue.progStr=progStr;
	zoneDessin.repaint();
    }

    public void lireFichier(String nom) {
	try {
	    URL source = new URL(getCodeBase(), nom);
	    progStr = FileStr.lireChaineFichier(source);
	}
	catch(Exception e) {
	    showStatus("URL inaccessible.");
	}
	if (progStr==null) showStatus("Lecture du fichier impossible.");
	else dessineFigure();
    }

 
}

