import java.applet.*;
import java.util.*;
import java.awt.*;
import java.net.*;
import jkb.geo3d.*;

// Applet Geo3dFig Version 0.0
// la figure est dfinie dans le paramtre "script" du fichier html

public class Geo3dFig extends Applet {
    Fig3d fig;

    public void init() {
	fig=new Fig3d();
 	setLayout(new BorderLayout());		
	add("Center", fig);
    }

    public void start() {
	String comstr;
	Double d;
	fig.R.recadre(getSize().width,getSize().height);
	comstr=getParameter("script");
	if (comstr!=null) execScript(comstr);
	d=null;
	comstr=getParameter("echelle");
	if (comstr!=null && comstr.length()>0) {
	    d=new Double(comstr);
	    if (d!=null) fig.R.fixeEchelle(d.doubleValue());
	}
	comstr=getParameter("affichage");
	if (comstr!=null) {
	    if (comstr.equals("0")) fig.affichageFilaire();
	    else if (comstr.equals("1")) fig.affichagePlein();
	    else if (comstr.equals("2")) fig.affichageFaces();
	    else if (comstr.equals("3")) fig.affichageConvexe();
	}
	comstr=getParameter("fichier");
	if (comstr!=null) lireFichier(comstr);
    }

    public void execCom(String S) {
	Script3d scr=new Script3d(S);
	scr.compile(fig);
	fig.repaint();
    }

    public void execScript(String S) {
	fig.vider();
	execCom(S);
    }

    public void raz() {
	fig.vider();
    }

    public void affiche() {
	fig.repaint();
    }

    public void echelle(double d) {
	fig.R.fixeEchelle(d);
	fig.repaint();
    }

    public void angleVue(double theta, double fi) {
	fig.R.setObsPhiObsTheta(fi,theta);
	fig.repaint();
    }

    public int statut(String nom) {
	Obj3d obj=fig.trouveObj(nom);
	if (obj!=null) return obj.statut;
	else return -1;
    }

    public double valeur(String nom, int code) {
	Point3d P;
	double rep=0;
	Obj3d obj=fig.trouveObj(nom);
	if (obj.estPoint()) {
	    P=(Point3d) obj;
	    switch (code) {
	    case 1 : 
		rep=P.donneX(); break;
	    case 2:
		rep=P.donneY(); break;
	    case 3:
		rep=P.donneZ(); break;
	    }
	}
	return rep;
    }

    public void modeAffichage(int n) {
	if (n==0) fig.affichageFilaire();
	else if (n==1) fig.affichagePlein();
	else if (n==2) fig.affichageFaces();
	else if (n==3) fig.affichageConvexe();
	fig.repaint();
    }

    public void lireFichier(String nomFichier) {
	boolean ok=true;
	URL source=null;
	Fichier3d f;
	int typ=0;
	try {
	    source = new URL(getDocumentBase(), nomFichier);
	}
	catch(Exception e) {
	    source=null;
	    showStatus("URL inaccessible.");
	}
	if (source!=null) {
	    fig.vider();
	    if (nomFichier.endsWith(".f3d")) typ=Fichier3d.F3D;
	    else if (nomFichier.endsWith(".off")) typ=Fichier3d.OFF;
	    else if (nomFichier.endsWith(".obj")) typ=Fichier3d.OBJ;
	    f=new Fichier3d(typ,source);
	    f.traiteFichier(fig);
	    fig.repaint();
	}
    }

    public void ajoutePoint(String S) {
	// permet de crer un point par JavaScript en donnant 
	// dans la chaine S ses coordonnes spares par des espaces
	Point3d P=new Point3d(0,0,0);
	StringTokenizer st=new StringTokenizer(S," ",false);
	String tmp;
	Double D;
	int i=0;
	while (st.hasMoreTokens() && i<3) {
	    tmp=st.nextToken();
	    D=new Double(tmp);
	    if (i==0) P.x=D.doubleValue();
	    else if (i==1) P.y=D.doubleValue();
	    else P.z=D.doubleValue();
	    i++;
	}
	fig.ajouteObj(P);
    }

    public void ajouteFace(String S) {
	// permet de crer une face par JavaScript en donnant
	// dans la chaine S les numros des points spars par des espaces
	Face f0=new Face();
	Point3d P;
	StringTokenizer st=new StringTokenizer(S," ",false);
	String tmp;
	Integer N;
	while (st.hasMoreTokens()) {
	    tmp=st.nextToken();
	    N=new Integer(tmp);
	    P=(Point3d)fig.donnePoint(N.intValue());
	    f0.ajouteSommet(P);
	}
	fig.ajouteObj(f0);
    }

}

