/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * Imageo.java
 * JDK 1.1  
 * Version 1.2 Rvision 07/08/2000
 * Applet fournissant une zone d'dition de script et une zone
 * de dessin pour une figure Imageo.
 *
 */

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import jkb.imageo.*;
import jkb.utils.FileStr;

public class Imageo extends Applet 
 implements ActionListener,KeyListener {
 public PlanImageo zoneDessin;
 public TextArea zoneTexte;
 public Label infoLabel;
 Button Dessin;
 Button Gomme;
 
 public void init() {
  Panel pan,pan2;
  Label lab;
  setLayout(new BorderLayout());
  pan=new Panel();
  pan.setLayout(new GridLayout(1,2));
  zoneTexte = new TextArea(20,30);
  zoneTexte.addKeyListener(this);
  pan.add(zoneTexte);
  zoneDessin = new PlanImageo();
  pan.add(zoneDessin);
  add("Center",pan);
  pan=new Panel();
  pan.setLayout(new GridLayout(1,2));
  pan.setBackground(new Color(192,192,192));
  pan2=new Panel();
  pan2.setLayout(new FlowLayout(FlowLayout.LEFT));
  pan2.setBackground(new Color(192,192,192));
  Dessin=new Button("Dessiner");
  Dessin.addActionListener(this);
  Gomme=new Button("Effacer");
  Gomme.addActionListener(this);
  pan2.add(Dessin);
  pan2.add(Gomme);
  pan.add(pan2);
  infoLabel=new Label(FigureImageo.ImageoVersion);
  infoLabel.setBackground(new Color(192,192,192));
  pan.add(infoLabel);  
  add("South",pan);
 }

 public void start() {
  String nom;
  nom=getParameter("editable");
  if (nom!=null && nom.equals("non")) zoneTexte.setEditable(false);
  nom=getParameter("un");
  if (nom!=null && nom.length()>0) {
   Double u=new Double(nom);
   if (!u.isNaN()) zoneDessin.fenetreOrthoCentre(u.doubleValue());
   } 
  nom=getParameter("fichier");
  if (nom!=null && nom.length()>0) {
    try {
     URL source = new URL(getCodeBase(), nom);
     String script=FileStr.lireChaineFichier(source);
     if (script!=null) {
      zoneTexte.setText(script);
      execScript();
     }
     else affMsg("Lecture fichier impossible.");
    }
    catch(Exception e) {
     e.printStackTrace();
    }
  }
 }

 public void affMsg(String S) {
  infoLabel.setText(S);
 }
 
 public String getAppletInfo() {
  return(FigureImageo.ImageoVersion);
 }

 public void execScript() {
  affMsg("Excution en cours...");
  ScriptImageo scr=new ScriptImageo(zoneTexte.getText());
  zoneDessin.Fig=scr.compile();
  affMsg(scr.messageErreur());
  zoneDessin.repaint();
 }
 
 public void actionPerformed(ActionEvent evt) {
  if (evt.getSource()==Dessin) execScript();
  else if (evt.getSource()==Gomme) {
   if (zoneTexte.isEditable()) {
    zoneDessin.Fig.vider();
    zoneDessin.repaint();
    zoneTexte.setText("");
    affMsg(FigureImageo.ImageoVersion);
   }
  }
 }
 
 public void keyPressed(KeyEvent evt) {
  if (evt.getKeyCode()==KeyEvent.VK_F9) execScript();
 }
 
 public void keyTyped(KeyEvent evt) {
 }
 
 public void keyReleased(KeyEvent evt) {
 }
 
}

