/*
 * Copyright (c) 1999 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * ImageoCons.java
 * JDK 1.1  
 * Version 1.1 Rvision 30/12/1999
 * Applet permettant d'afficher tape par tape une figure Imageo dfinie 
 * dans un fichier.
 * Paramtres du tag Applet :
 * NAME fichier VALUE "nom_du_fichier"
 * NAME mobile VALUE "oui" ou "non"
 *
 */

import java.util.*;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import jkb.imageo.*;

public class ImageoCons extends Applet 
    implements ActionListener,KeyListener  {
 ConstImageo zoneDessin;
 TextArea zoneTexte;
 Button Avance,Recule;
 
 public void init() {
  Panel pan;
  Panel panb;
  setLayout(new GridLayout(1,2));
  pan=new Panel();
  pan.setLayout(new BorderLayout());
  pan.setBackground(new Color(192,192,192));
  zoneTexte=new TextArea(30,30);
  zoneTexte.addKeyListener(this);
  zoneTexte.setEditable(false);
  pan.add("Center",zoneTexte);
  panb=new Panel();
  panb.setBackground(new Color(192,192,192));
  Recule=new Button("<=");
  Recule.addActionListener(this);
  panb.add(Recule);
  Avance=new Button("=>");
  Avance.addActionListener(this);
  panb.add(Avance);
  pan.add("South",panb);
  add(pan);
  zoneDessin=new ConstImageo();
  add(zoneDessin);
 }

 public void start() {
  String comstr;
  comstr=getParameter("mobile");
  if (comstr!=null && comstr.length()>0) {
   if (comstr.compareTo("oui")==0) zoneDessin.rendreMobile(true);
   else zoneDessin.rendreMobile(false);
  }
  comstr=getParameter("fichier");
  if (comstr!=null && comstr.length()>0) {
   try {
    URL source = new URL(getCodeBase(), comstr);
    zoneDessin.lireFichierConst(source);
   }
   catch(Exception e) {
    e.printStackTrace();
   }
  }
  fixeEtape(0);
 }  

 public void fixeEtape(int num) {
  zoneDessin.fixeEtape(num);
  //zoneDessin.repaint();
  zoneTexte.setText(zoneDessin.donneInfo(zoneDessin.etapeCourante));
  //zoneTexte.invalidate();
 }

 public void actionPerformed(ActionEvent evt) {
  if (evt.getSource()==Avance) {
   fixeEtape(zoneDessin.etapeCourante+1);
  } 
  else if (evt.getSource()==Recule) {
   fixeEtape(zoneDessin.etapeCourante-1);
  } 
 }
 
 public void keyPressed(KeyEvent evt) {
  int key=evt.getKeyCode();
  if (key==KeyEvent.VK_RIGHT) {
   fixeEtape(zoneDessin.etapeCourante+1);
  }
  else if (key==KeyEvent.VK_LEFT) {
   fixeEtape(zoneDessin.etapeCourante-1);
  } 
 }
 
 public void keyTyped(KeyEvent evt) {
 }
 
 public void keyReleased(KeyEvent evt) {
 }
 
 
 public void execFile(String S) {
  if (S!=null && S.length()>0) {
   try {
    URL source = new URL(getCodeBase(), S);
    zoneDessin.lireFichierConst(source);
   }
   catch(Exception e) {
    e.printStackTrace();
   }
  }
  fixeEtape(0);
 }
}

