/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * ImageoFig.java
 * JDK 1.1 
 * Version 1.2 Rvision 07/08/2000
 * Applet permettant d'afficher une figure Imageo dfinie 
 * dans un fichier.
 * Paramtres du tag Applet :
 * NAME fichier VALUE "nom_du_fichier"
 * NAME mobile VALUE "oui" ou "non"
 * NAME un VALUE "nombre de pixels par unit"
 *  la valeur par dfaut est 20 
 * NAME script VALUE "script imageo"
 *
 */

//import java.util.*;
import java.applet.Applet;
import java.awt.*;
import java.net.*;
import jkb.imageo.*;
import jkb.utils.FileStr;


public class ImageoFig extends Applet {
 PlanImageo zoneDessin;
 
 public void init() {
  zoneDessin=new PlanImageo();
  setLayout(new BorderLayout());
  add("Center",zoneDessin);
 }

 public void start() {
  String comstr;
  Double u,x0,y0;
  comstr=getParameter("mobile");
  if (comstr!=null && comstr.length()>0) {
   if (comstr.compareTo("oui")==0) zoneDessin.rendreMobile(true);
   else zoneDessin.rendreMobile(false);
  }
  u=null; x0=null; y0=null;
  comstr=getParameter("un");
  if (comstr!=null && comstr!="") {
   u=new Double(comstr);
   comstr=getParameter("xmin");
   if (comstr!=null && comstr!="") {
       x0 = new Double(comstr);
       comstr=getParameter("xmin");
       if (comstr!=null && comstr!="") {
	  y0 = new Double(comstr);
       }
   }
   if (u!=null && x0!=null && y0!=null) {
     zoneDessin.optionOrtho=false;
     zoneDessin.fenetreOrtho(u.doubleValue(),x0.doubleValue(),y0.doubleValue());
   }
   else 
   if (u!=null)  zoneDessin.fenetreOrthoCentre(u.doubleValue());
  } 
  comstr=getParameter("quadrillage");
  if (comstr!=null && comstr.equals("oui")) {
   zoneDessin.optQuadrillage=true;
   zoneDessin.optAxes=true;
  }
  comstr=getParameter("script");
  if (comstr!=null) execScript(comstr);
  comstr=getParameter("fichier");
  if (comstr!=null && comstr.length()>0) {
   lireFichier(comstr);
  }
 }  

 public String getAppletInfo() {
  return(FigureImageo.ImageoVersion);
 }

 public void execScript(String S) {
  ScriptImageo scr=new ScriptImageo(S);
  zoneDessin.Fig=scr.compile();
  if (scr.codeErreur!=0) {
   showStatus(scr.messageErreur());
  }
  zoneDessin.repaint();
 }
 
 public void lireFichier(String nom) {
  String script=null;
  try {
   URL source = new URL(getCodeBase(), nom);
   script = FileStr.lireChaineFichier(source);
  }
  catch(Exception e) {
   showStatus("URL inaccessible.");
  }
  if (script==null) showStatus("Lecture du fichier impossible.");
  else execScript(script);
 }

 public double valeur(String nom, int num) {
  ObjImageo obj=zoneDessin.Fig.trouveObj(nom);
  if (obj!=null) {
   switch (num) {
    case 1 : return obj.donneA();
    case 2 : return obj.donneB();
    case 3 : return obj.donneC();
    default : return 0;
   }
  }
  else return 0; 
 } 

 public void bouge(String nom, double x, double y) {
  ObjImageo obj=zoneDessin.Fig.trouveObj(nom);
  if (obj!=null && obj.donneType()==ObjImageo.iPoint) {
   int xx=zoneDessin.xEcran(x);
   int yy=zoneDessin.yEcran(y);
   if (zoneDessin.contains(xx,yy)) {
    ((jkb.imageo.Point) obj).bougeVers(x,y);
    zoneDessin.repaint();
   }
  }
 }

}

