import java.awt.*;

public class HistoGra extends Canvas {
 
 HistoData hist;
 double maxi=100.0;
 double pasGradu=10.0;
 Font font;
 Image img=null;
 Graphics gimg=null;
 
 public HistoGra(HistoData hist) {
  setBackground(Color.white);
  setForeground(Color.blue);
  this.hist=hist;
  font=new Font("SansSerif",Font.BOLD,10);
 }

 public void setMaxi(double d) {
  maxi=d;
 }
 
 public void setPasGradu(double d) {
  pasGradu=d;
 }
 
 public int calcHauteur(double d, int h) {
  return (int)Math.floor(d*h/maxi);
 }
 
 public void update(Graphics g) {
  paint(g);
 }
 
 public void paint(Graphics g) {
  int nbDatas=hist.nbVals();
  if (img==null) {
   img=createImage(getSize().width, getSize().height);
   gimg=img.getGraphics();
   gimg.setFont(font);
  } 
  int marge=10;
  int largeur=getSize().width-3*marge;
  int hauteur=getSize().height-3*marge;
  int x=2*marge;
  int y=0;
  int largeurItem=largeur/nbDatas;
  gimg.setColor(Color.white);
  gimg.fillRect(0,0,getSize().width, getSize().height); 
  for (int i=0; i<nbDatas; i++) {
   y=calcHauteur(hist.getDataVal(i),hauteur);
   gimg.setColor(Color.blue);
   gimg.fillRect(x,marge+hauteur-y,largeurItem,y);
   gimg.setColor(Color.black);
   gimg.drawRect(x,marge+hauteur-y,largeurItem,y);
   gimg.drawString(hist.getDataNom(i),x+largeurItem/2,hauteur+2*marge);
   x=x+largeurItem;
  }
  gimg.setColor(Color.black);
  gimg.drawLine(2*marge,hauteur+marge,largeur+marge,hauteur+marge);
  //axe des ordonnes
  gimg.drawLine(2*marge,hauteur+marge,2*marge,0);
  double d=10;
  while (d<maxi) {
   y=marge+hauteur-calcHauteur(d,hauteur);
   gimg.drawString(" "+(int)d,0,y);
   gimg.drawLine(2*marge-2,y,2*marge+2,y);
   d=d+pasGradu;
  }
  //transfert de l'image
  g.drawImage(img,0,0,this);  
 }
 
}

