import java.awt.*;
import java.text.DecimalFormat;

public class UrneArbre extends Canvas {
 UrneModel urne=new UrneModel();
 boolean montreProba;  // affichage ou non des probabilits 
 int largeurNoeud;     // largeur d'une branche de l'arbre 
 int hauteurArbre = 27*12;   // hauteur de l'arbre 
 int margeHaut=32;           // au dessus de l'arbre }
 int margeGauche=16;         //  gauche de l'arbre }
 DecimalFormat df=new DecimalFormat("###0.000");
 FontMetrics fm;
 
 public UrneArbre() {
  montreProba=false;
  setBackground(Color.white);
  Font fonte=new Font("SansSerif",Font.PLAIN,10);
  setFont(fonte);
  fm=getFontMetrics(fonte);
 }
 
 public void paint(Graphics g) {
  String S;
  int x,y;
  double r;
  largeurNoeud=getSize().width/6;
  //titres
  g.setColor(Color.black);
  g.drawString("Freq",(urne.nbTirage)*largeurNoeud+margeGauche+4*8+4,margeHaut-12);
  if (montreProba) 
   g.drawString("Prob",(urne.nbTirage)*largeurNoeud+margeGauche+4*8+44,margeHaut-12);
  //dessin de l'arbre
  for (int i=0; i<27; i++) 
   if (urne.tabChoix[i]) dessineChemin(g,i);
  //infos
  y=hauteurArbre+margeHaut+4;
  y=y+20;
  g.setColor(Color.black);
  S=""+urne.tirages;
  if (urne.tirages<=1) S=S+" tirage effectu";
  else S=S+" tirages effectus";
  if (urne.remise) S=S+" [avec ";
  else S=S+" [sans ";
  g.drawString(S+" remise]",4,y);
  y=y+16;
  x=4;
  S="Composition : ";
  g.drawString(S,x,y);
  x=x+fm.stringWidth(S)+4;
  g.setColor(Color.blue);
  S=""+urne.nbBleu;
  g.drawString(S,x,y);
  x=x+fm.stringWidth(S)+4;
  g.setColor(Color.red);
  S=""+urne.nbRouge;
  g.drawString(S,x,y);
  x=x+fm.stringWidth(S)+4;
  g.setColor(Color.green);
  S=""+urne.nbVert;
  g.drawString(S,x,y);
 }
 
 Color getLineColor(char c) {
  switch (c) {
   case 'B': return Color.blue;
   case 'R': return Color.red;
   case 'V': return Color.green;
   default : return Color.white;
  }
 }

 void dessineChemin(Graphics g, int n) {
  int x1,y1,x2,y2,i;
  String S;
  int lS;
  S=urne.defTirage(n);
  lS=S.length();
  x1=margeGauche; y1=margeHaut+hauteurArbre/2;
  g.setColor(Color.black);
  g.drawOval(x1-3,y1-3,6,6);
  if (lS>=1) {
   g.setColor(getLineColor(S.charAt(0)));
   x2=x1+largeurNoeud;
   switch (S.charAt(0)) {
    case 'B' : 
     y2=y1-hauteurArbre/3;
     break;
    case 'V' : 
     y2=y1+hauteurArbre/3;
     break;
    default : y2=y1; 
   } 
   g.drawLine(x1,y1,x2,y2);
   x1=x2; y1=y2;
   g.setColor(Color.black);
  } 
  if (lS>1) g.drawOval(x1-3,y1-3,6,6);
  if (lS>=2) {
   g.setColor(getLineColor(S.charAt(1)));
   x2=x1+largeurNoeud;
   switch (S.charAt(1)) {
    case 'B' : 
     y2=y1-hauteurArbre/9;
     break;
    case 'V' : 
     y2=y1+hauteurArbre/9;
     break;
    default : y2=y1;
   } 
   g.drawLine(x1,y1,x2,y2);
   x1=x2; y1=y2;
   g.setColor(Color.black);
   if (lS>2) g.drawOval(x1-3,y1-3,6,6);
  } 
  if (lS>=3) {
   g.setColor(getLineColor(S.charAt(2)));
   x2=x1+largeurNoeud;
   switch (S.charAt(2)) {
    case 'B' : 
     y2=y1-hauteurArbre/27;
     break;
    case 'V' : 
     y2=y1+hauteurArbre/27;
     break;
    default :
     y2=y1;
   }  
   g.drawLine(x1,y1,x2,y2);
   x1=x2; y1=y2;
  } 
  printFreq(g, x1, y1+4, n);
 } 
 
 
 void printFreq(Graphics g, int x, int y, int n) {
  g.setColor(Color.black);
  g.drawString(urne.defTirage(n),x+4, y);
  g.drawString(df.format(urne.frequence(n)), x+36, y);
  if (montreProba) g.drawString(df.format(urne.tabProba[n]), x+76, y);
 }

}

