/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * buffon.java
 * JDK 1.1  
 * Version 1.1 Rvision 03/06/2000
 * Applet permettant de calculer pi par la mthode de Buffon.
 *
 */

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import jkb.calkul.*;
import jkb.utils.*;
import jkb.geom.*;

public class buffon extends Applet implements ActionListener {
 Plan zoneDessin;
 Label zoneInfo;
 int nbAiguilles;
 int nbAiguillesSurLigne;
 double pas=2.0;
 
 public void init() {
  setLayout(new BorderLayout());
  zoneDessin=new Plan();
  Panel pan=new Panel();
  Button but=new Button("Tirages");
  but.addActionListener(this);
  pan.add(but);
  but=new Button("Recommencer");
  but.addActionListener(this);
  pan.add(but);
  add("Center",zoneDessin);
  add("South",pan);
  zoneInfo=new Label();
  add("North",zoneInfo);
 }
 
 public void start() {
  nbAiguilles=0;
  nbAiguillesSurLigne=0;
  zoneInfo.setText("Aiguilles de Buffon");
  Graphics g=zoneDessin.donneCG();
  zoneDessin.fenetreOrthoCentre(16);
  zoneDessin.couleurFond=Color.white;
  zoneDessin.dessineFond(g);
  double c=0.0;
  double pas=2.0;
  while (c>=zoneDessin.xMin()) {
   zoneDessin.afficheDroite(g,1,0,-c,Color.black);
   c=c-pas;
  }
  c=pas;
  while (c<=zoneDessin.xMax()) {
   zoneDessin.afficheDroite(g,1,0,-c,Color.black);
   c=c+pas;
  }
  g.dispose();
  zoneDessin.repaint();
 }

 public void actionPerformed(ActionEvent evt) {
  if (evt.getActionCommand().equals("Tirages")) tirages();
  else if (evt.getActionCommand().equals("Recommencer")) start();
 }
 
 public void tirages() {
  double x,y,xx,yy,a;
  Graphics g=zoneDessin.donneCG();
  for (int i=0; i<1000; i++) {
   do {
    x=zoneDessin.xMin()+Math.random()*(zoneDessin.xMax()-zoneDessin.xMin());
    y=zoneDessin.yMin()+Math.random()*(zoneDessin.yMax()-zoneDessin.yMin());
    a=Math.random()*Math.PI*2;
    xx=x+Math.cos(a)*pas/2;
    yy=y+Math.sin(a)*pas/2;
   } while (xx<zoneDessin.xMin() || xx>zoneDessin.xMax() 
         || yy<zoneDessin.yMin() || yy>zoneDessin.yMax() );
   nbAiguilles++;
   a=0.0;
   if (x>a) {
    while (x>a) a=a+pas;
    a=a-pas;
   }
   else {
    while (x<a) a=a-pas;
   }
   if (xx>=a+pas || xx<=a) {
    nbAiguillesSurLigne++;
    g.setColor(Color.red);
    zoneDessin.traceVers(g,x,y,0);
    zoneDessin.traceVers(g,xx,yy,1);
   }
  }
  g.dispose();
  zoneDessin.repaint();
  x=(double)nbAiguilles/(double)nbAiguillesSurLigne;
  String S="Total : "+nbAiguilles+" Rsultat : "+Div.DoubleToStr(x,4);
  zoneInfo.setText(S);
 }
 
 
}

