/*
 * Copyright (c) 2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * BoolStr.java
 * JDK 1.1  
 * Version 1.0 Rvision 15/07/2000
 * Partie du package calkul interprtant une chane de caractres
 * en tant que formule boolenne : a=b, a<b, a>b, a<=b, a>=b ou
 * a<>b.
 *
 */

package jkb.calkul;

import java.util.Hashtable;
import java.util.Vector;

/**
 * Classe du package calkul permettant d'valuer une
 * une chane de caractres.
 */
public class BoolStr extends MathStr {

 public final static int errComp=maxErrMathStr+1;
 public final static String compCars="=><";
 
 /**
  * Constructeur de l'objet; attend la chane  valuer
  * en paramtre. Mode radian pour les angles.
  */
 public BoolStr(String S) {
  super(S,compCars);
 }

 /**
  * Constructeur de l'objet; attend la chane  valuer
  * en paramtre. Mode radian pour les angles.
  */
 public BoolStr(String S, String sep) {
  super(S,compCars+sep);
 }

 int lireTypeComp() {
  int bType=0;
  passeEspaces();
  switch (suivant) {
   case '=' :
    bType=MathNode.tEgal;
    lireSuivant();
    break;
   case '<' :
    lireSuivant();
    if (suivant=='>') {
     bType=MathNode.tDiff;
     lireSuivant();
    }
    else if (suivant=='=') {
     bType=MathNode.tInfEgal;
     lireSuivant();
    }
    else bType=MathNode.tInf;
    break;
   case '>' :
    lireSuivant();
    if (suivant=='=') {
     bType=MathNode.tSupEgal;
     lireSuivant();
    }
    else bType=MathNode.tSup;
    break;
   default :
    marqueErreur(errComp);
  }
  return bType;
 }
 
 public MathNode evalBoolItem(Hashtable h, boolean tout) {
  MathNode rep=null;
  MathNode m1,m2;
  int bType;
  //lecture du premier membre
  m1=evalExp(h,false);
  //type de comparaison
  if (codeErreur==0) {
   bType=lireTypeComp();
   //lecture du deuxime membre
   if (codeErreur==0) {
    passeEspaces();
    m2=evalExp(h,false);
    if (codeErreur==0) {
     rep=new MathNode(bType,null);
     rep.ajouteBranche(m1);
     rep.ajouteBranche(m2);
    }
   }
  }
  return rep;
 }
 
 public String messageErreur() {
  if (codeErreur==errComp) return "Comparaison attendue.";
  else return super.messageErreur();
 }
 
}


