/*
 * Copyright (c) 2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * EvalStr.java
 * JDK 1.1  
 * Version 1.0 Rvision 15/06/2000
 * Partie du package calkul pour calculer une chaine de caractres.
 * Ne contient que des fonctions statiques.
 */

package jkb.calkul;

import java.util.Hashtable;
import jkb.utils.Div;

/**
 * Classe du package calkul permettant de calculer des
 * expressions mathmatiques fournies sous forme de chaines
 * de caractres.
 */
public class EvalStr {

 private EvalStr() {
 }
 
 /**
  * Fonction statique qui value totalement une chane de
  * caractres et renvoie une rponse de double.
  */
 public static double eval(String S, Hashtable dic, int mAngle) {
  Hashtable dico;
  double rep=Double.NaN;
  MathStr F=new MathStr(S);
  if (dic!=null) dico=dic;
  else {
   dico=new Hashtable();
   MathNode.initDico(dico);
  } 
  int ma=MathNode.modeAngle;
  MathNode.modeAngle=mAngle;
  MathNode exp=F.evalExp(dico,true);
  if (exp!=null) rep=exp.donneValeur();
  MathNode.modeAngle=ma; 
  return rep;
 }
 
 /**
  * Fonction statique qui value totalement une chane de
  * caractres et renvoie une rponse sous forme de chane.
  */
 public static String evalStr(String S, Hashtable dic, int mAngle) {
  Hashtable dico;
  String rep="";
  MathStr F=new MathStr(S);
  if (dic!=null) dico=dic;
  else {
   dico=new Hashtable();
   MathNode.initDico(dico);
  } 
  int ma=MathNode.modeAngle;
  MathNode.modeAngle=mAngle;
  MathNode exp=F.evalExp(dico,true);
  if (exp!=null) {
   double d=exp.donneValeur();
   if (Div.errCalc(d)) rep="Erreur de calcul.";
   else rep=Div.DoubleToStr(d,8);
  }
  else rep=F.messageErreur();
  MathNode.modeAngle=ma;
  return rep;
 }
 
}

