package jkb.geo3d;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

public class Espace extends Canvas implements MouseListener,MouseMotionListener  {
    final static String FONTE_TEXTE = "SansSerif";
    public int tailleFonte=12;
    public Color couleurDessin=Color.black;
    public Color couleurCache=Color.lightGray;
    public Color couleurFond=Color.white;
    public Color couleur=Color.black;
    public Repere R;
    public Dessinateur D;
    int xSouris, ySouris;
    int boutonSouris=0;
    int xCur=0;
    int yCur=0;
    // image contenant la figure utilise pour le double buffering
    public Image img;
    public boolean utiliseImage=false;

    public Espace() {
	R=new Repere();
	addMouseListener(this);
	addMouseMotionListener(this);
	img=null;
	D=null;
    }

    // garder les angles entre 0 et 360
    public double recadreAngle(double a) {
	double rep=a;
	while (rep<0) rep=rep+360;
	while (rep>360) rep=rep-360;
	return rep;
    }

    public void update(Graphics g) {
	paint(g);
    }

    public void paint(Graphics g) {
	int largeur=getWidth();
	int hauteur=getHeight();
	if (R.largeur==0 || R.hauteur==0) R.recadre(largeur,hauteur);
	if (D!=null) D.dessineFig(g);
	/**
	if (utiliseImage && img==null) img=createImage(R.largeur, R.hauteur);
	else {
	    g.setColor(couleurFond);
	    g.fillRect(0,0,largeur,hauteur);
	}
	dessineFig(g);
	**/
    }

    /**
    public void dessineFig(Graphics g) {
	if (utiliseImage && img!=null) g.drawImage(img,0,0,this);
    }
    **/

    // gestion de la souris
    public void mouseClicked(MouseEvent e) {}

    public void mousePressed(MouseEvent e) {
	xSouris=e.getX();
	ySouris=e.getY();
	boutonSouris=e.getButton();
    }
	
    public void mouseReleased(MouseEvent e) {
	boutonSouris=0;
    }

    public void mouseEntered(MouseEvent e) {}

    public void mouseExited(MouseEvent e) {}

    public void mouseDragged(MouseEvent e) {
	int xm=e.getX();
	int ym=e.getY();
	if (contains(xm,ym)) {
	    if (boutonSouris==MouseEvent.BUTTON1) {
		if (Math.abs(ym-ySouris)>Math.abs(xm-xSouris)) 
		    R.setObsPhiObsTheta(recadreAngle(R.obsPhi+ym-ySouris),R.obsTheta);
		else 
		    R.setObsPhiObsTheta(R.obsPhi,recadreAngle(R.obsTheta+xSouris-xm));
	    }
	    else if (boutonSouris==MouseEvent.BUTTON2 || boutonSouris==MouseEvent.BUTTON3) {
		R.deplace(xm-xSouris,ym-ySouris);
	    }
	    xSouris=xm; ySouris=ym;
	    repaint();
	} 
    }

    public void mouseMoved(MouseEvent e) {}

    public void choixCouleurPoint(Point3d P) {
    }

    public void tracePoint(Graphics g, Point3d P) {
	int[] c;
	c=R.coordEcran(P.x,P.y,P.z);
	choixCouleurPoint(P);
	g.setColor(couleur);
	if (P.marque) {
	    g.drawLine(c[0]-2,c[1],c[0]+2,c[1]);
	    g.drawLine(c[0],c[1]-2,c[0],c[1]+2);
	}
	if (P.nom.length()>0) {
	    Font fo=new Font(FONTE_TEXTE,Font.PLAIN,tailleFonte);
	    g.setFont(fo);
	    FontMetrics fm=g.getFontMetrics(fo);
	    int l=fm.stringWidth(P.nom);
	    int h=fm.getHeight();
	    if (c[0]>=getWidth()/2) c[0]=c[0]+4; else c[0]=c[0]-l-4;
	    if (c[1]>=getHeight()/2) c[1]=c[1]+h-4; 
	    g.drawString(P.nom,c[0],c[1]);
	}
    }

    public void choixCouleurSegment(Point3d P1, Point3d P2) {
    }

    public void traceSegment(Graphics g, Point3d P1, Point3d P2) {
	// trac d'un segment lmentaire, c-a-d qui ne coupe pas des faces
	int[] c1, c2;
	choixCouleurSegment(P1,P2);
	if (couleur!=null) {
	    c1=R.coordEcran(P1.x,P1.y,P1.z);
	    c2=R.coordEcran(P2.x,P2.y,P2.z);
	    choixCouleurSegment(P1,P2);
	    g.setColor(couleur);
	    g.drawLine(c1[0], c1[1], c2[0], c2[1]);
	}
    }

    public void traceVers(Graphics g, double x, double y, double z, int mode) {
	int [] c;
	c=R.coordEcran(x,y,z);
	if (mode==1) g.drawLine(xCur,yCur,c[0],c[1]);
	xCur=c[0]; yCur=c[1];
    }

    public void grosPoint(Graphics g, int rayon) {
	g.fillOval(xCur, yCur, rayon, rayon);
    }
}
