package jkb.geo3d;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

public class Fig3d extends Espace implements Dessinateur {
    boolean recalcAretes=true;
    int modeAffichage=1;  //ou 0 pour affichage filaire ou 2 pour affichage faces ou 3 convexe
    Vector faces;
    Vector points;
    Vector segments;
    Vector aretes;
    Vector pyramide;
    Color couleurFace=Color.yellow;

    public Fig3d() {
	D=this;
	faces=new Vector(10,10);
	points=new Vector(20,20);
	segments=new Vector(10,10);
	aretes=new Vector(10,10);
	pyramide=new Vector(10,10);
    }


    public void affichagePlein() {
	modeAffichage=1;
    }

    public void affichageFilaire() {
	modeAffichage=0;
    }

    public void affichageFaces() {
	modeAffichage=2;
    }

    public void affichageConvexe() {
	modeAffichage=3;
    }

    // gestion des lments de figure
    public Obj3d trouveObj(String n) {
	Point3d P;
	Segment3d S;
	Face F;
	Obj3d rep=null;
	// est-ce un point
	int i=0;
	while (rep==null && i<points.size()) {
	    P=(Point3d) points.elementAt(i);
	    if (P.nom.equals(n)) rep=P;
	    else i++;
	}
	// est-ce un segment
	i=0;
	while (rep==null && i<segments.size()) {
	    S=(Segment3d) segments.elementAt(i);
	    if (S.nom.equals(n)) rep=S;
	    else i++;
	}
	// est-ce une face
	i=0;
	while (rep==null && i<faces.size()) {
	    F=(Face) faces.elementAt(i);
	    if (F.nom.equals(n)) rep=F;
	    else i++;
	}
	// est-ce une arte.... faire.... 
	return rep;
    }

    public Point3d donnePoint(int n) {
	return (Point3d)points.elementAt(n); 
    }

    public void ajouteObj(Obj3d obj) {
	if (obj.estPoint()) points.addElement(obj);
	else if (obj.estSegment()) {
	    segments.addElement(obj);
	    recalcAretes=true;
	}
	else if (obj.estFace()) {
	    faces.addElement(obj);
	    recalcAretes=true;
	}
    }

    public void vider() {
	faces.removeAllElements();
	segments.removeAllElements();
	points.removeAllElements();
	aretes.removeAllElements();
	pyramide.removeAllElements();
	recalcAretes=true;
    }

    // utilitaires pour affichage
    public void inserePoint(Point3d M, Vector v) {
	int i=0;
	Point3d M1,M2;
	Segment3d S;
	double k;
	boolean fini=false;
	while (!fini && i<v.size()-1) {
	    M1=(Point3d)v.elementAt(i);
	    M2=(Point3d)v.elementAt(i+1);
	    if (M.coincide(M1) || M.coincide(M2)) fini=true;
	    else {
		S=new Segment3d(M1,M2);
		k=S.coeffAlignement(M);
		if (k>=0 && k<=1) {
		    v.insertElementAt(M,i+1);
		    fini=true;
		}
	    }
	    i++;
	}
    }

    public Vector decoupe(Segment3d S) {
	//dcoupe le segment en sous segments dlimits par les faces
	Vector rep=new Vector(10);
	int i=0;
	Face f;
	Point3d P;
	rep.addElement(S.P1);
	rep.addElement(S.P2);
	// intersection avec les faces
	for (i=0; i<faces.size(); i++) {
	    f=(Face)faces.elementAt(i);
	    P=Face.intersection(S,f,R);
	    if (P.estValide()) inserePoint(P,rep);
	}
	// intersection avec la pyramide de vision
	for (i=0; i<pyramide.size(); i++) {
	    f=(Face)pyramide.elementAt(i);
	    P=Face.intersection(S,f,R);
	    if (P.estValide()) inserePoint(P,rep);
	}
	return rep;
    }

    public boolean pointVu(Point3d P) {
	boolean rep=true;
	Face f;
	int i=0;
	while (rep && i<faces.size()) {
	    f=(Face)faces.elementAt(i);
	    if (f.visible && f.cache(P,R)) rep=false;
	    i++;
	}
	return rep;
    }

    public boolean segmentVu(Point3d P1, Point3d P2) {
	Point3d M=Point3d.milieu(P1,P2);
	return pointVu(M);
    }

    public boolean faceVue(Face f) {
	Point3d G=Point3d.isoBarycentre(f.sommets);
	return pointVu(G);
    }

    // affichage de la figure

    public void choixCouleurSegment(Point3d P1, Point3d P2) {
	couleur=couleurDessin;
	if (modeAffichage>0) {
	    boolean b=segmentVu(P1,P2);
	    if (modeAffichage==1 && !b) couleur=couleurCache;
	    if (modeAffichage==2 && !b) couleur=null;
	}
    }

    public Segment3d prolonge(Segment3d S) {
	Segment3d rep;
	Point3d M1, M2;
	double k;
	double loin=100;
	double d=Point3d.distance(S.P1,S.P2);
	if (Math.abs(d)==Point3d.zero) rep=S;
	else {
	    k=(loin+d)/d;
	    M1=new Point3d(S.P2.x+(S.P1.x-S.P2.x)*k,S.P2.y+(S.P1.y-S.P2.y)*k,
			   S.P2.z+(S.P1.z-S.P2.z)*k);
	    M2=new Point3d(S.P1.x+(S.P2.x-S.P1.x)*k,S.P1.y+(S.P2.y-S.P1.y)*k,
			   S.P1.z+(S.P2.z-S.P1.z)*k);
	    rep=new Segment3d(M1,M2);
	}
	return rep;
    }

    public void traceSegmentCoupe(Graphics g, Segment3d S) {
	Vector v;
	Point3d M1, M2;
	Segment3d SS;
	SS=S;
	if (S.type==Obj3d.iDroite) SS=prolonge(S);
	if (modeAffichage==0) traceSegment(g,SS.P1,SS.P2);
	else {
	    v=decoupe(SS);
	    if (v.size()>1) {
		for (int i=0; i<v.size()-1; i++) {
		    M1=(Point3d)v.elementAt(i);
		    M2=(Point3d)v.elementAt(i+1);
		    traceSegment(g,M1,M2);
		}
	    }
	}
    }

    public void choixCouleurPoint(Point3d P) {
	if (modeAffichage==1 && !pointVu(P)) couleur=couleurCache;
	else couleur=couleurDessin;
    }


    public void traceFace(Graphics g, Face f, boolean bord) {
	Point3d P1,P2;
	/**
	int nbSommets=f.sommets.size();
	   for (int i=0; i<nbSommets; i++) {
	    P1=(Point3d) f.sommets.elementAt(i);
	    if (i+1<nbSommets) P2=(Point3d) f.sommets.elementAt(i+1);
	    else P2=(Point3d) f.sommets.elementAt(0);
	    traceSegment(g,P1,P2);
	}
	**/
	Polygon P=f.fairePolygone(R);
	g.setColor(couleurFace);
	g.fillPolygon(P);
	if (bord) {
	    g.setColor(couleurDessin);
	    g.drawPolygon(P);
	}
    }

    public void insereArete(Segment3d S) {
	Segment3d S1;
	boolean existe=false;
	int i=0;
	while (!existe && i<aretes.size()) {
	    S1=(Segment3d)aretes.elementAt(i);
	    if (S1.coincide(S)) existe=true;
	    i++;
	}
	if (!existe) aretes.addElement(S);
    }

    public void calculAretes() {
	//recensement des artes dfinies par les faces
	Face f;
	Segment3d S,S1;
	triFaces();
	aretes.removeAllElements();
	for (int i=0; i<faces.size(); i++) {
	    f=(Face)faces.elementAt(i);
	    if (f.visible && f.estValide() && f.type==Obj3d.iFace) {
		for (int j=0; j<f.sommets.size(); j++) {
		    S=f.donneArete(j);
		    insereArete(S);
		}
	    }
	}
	//ne pas tracer les segments qui sont des artes
	for (int i=0; i<segments.size(); i++) {
	    S=(Segment3d)segments.elementAt(i);
	    boolean fini=false;
	    int j=0;
	    while (!fini && j<aretes.size()) {
		S1=(Segment3d)aretes.elementAt(j);
		if (S.coincide(S1)) {
		    S.visible=false;
		    fini=true;
		}
		j++;
	    }
	}
    }

    public void calcPyramide() {
	Segment3d S;
	Point3d P;
	Face f;
	int[] c;
	pyramide.removeAllElements();
	Point3d obs=new Point3d(R.xObs,R.yObs,R.zObs);
	Point3d origine=new Point3d(0,0,0);
	for (int i=0; i<aretes.size(); i++) {
	    S=(Segment3d)aretes.elementAt(i);
	    P=S.P1.translate(origine,obs);
	    f=Face.plan("",P,S.P1,S.P2);
	    if (f.estValide()) pyramide.addElement(f);
	}
    }

    public double distFace(Face f) {
	//Point3d obs=new Point3d(R.xObs,R.yObs,R.zObs);
	Point3d G=Point3d.isoBarycentre(f.sommets);
	return R.distEcran-R.zVision(G.donneX(), G.donneY(), G.donneZ());
	//return  Point3d.vecteur(obs,G).norme();
	/**Point3d P;
	double rep=0;
	int n=f.sommets.size();
	for (int i=0; i<n; i++) {
	    P=f.donneSommet(i);
	    rep=rep+Point3d.vecteur(obs,P).norme();
	}
	if (n!=0) rep=rep/n; 
	return rep; **/
    }

    public int indiceDistMin(int nmax) {
	int rep=0;
	Face f=(Face)faces.elementAt(0);
	double dmin=distFace(f);
	double d;
	for (int i=1; i<nmax; i++) {
	    f=(Face)faces.elementAt(i);
	    d=distFace(f);
	    if (d<dmin) {
		rep=i; dmin=d;
	    }
	}
	return rep;
    }

    public void triFaces() {
	int imin;
	Face f1,f2;
	for (int i=faces.size(); i>0; i--) {
	    imin=indiceDistMin(i);
	    if (imin!=i-1) {
		f1=(Face)faces.elementAt(i-1);
		f2=(Face)faces.elementAt(imin);
		faces.setElementAt(f1, imin);
		faces.setElementAt(f2, i-1);
	    }
	}
    }


    public void traceFig(Graphics g) {
	Vector v;
	Point3d P;
	Segment3d S;
	Face f;
	g.setColor(couleurFond);
	g.fillRect(0,0,R.largeur,R.hauteur);
	if (modeAffichage<3 && recalcAretes) {
	    calculAretes();
	    recalcAretes=false;
	}
	if (modeAffichage<2) {
	    if (modeAffichage==1) {
		triFaces(); 
		calcPyramide();
	    }
	    // les segments
	    for (int i=0; i<segments.size(); i++) {
		S=(Segment3d) segments.elementAt(i);
		if (S.visible && S.estValide()) traceSegmentCoupe(g,S);
		//else if (S.visible && S.type==Obj3d.iDroite) traceDroite(g,S.P1,S.P2);
	    }
	    // les artes
	    for (int i=0; i<aretes.size(); i++) {
		S=(Segment3d)aretes.elementAt(i);
		//traceSegment(g, S.P1, S.P2);
		traceSegmentCoupe(g,S);
	    }
	    // les points
	    for (int i=0; i<points.size(); i++) {
		P=(Point3d) points.elementAt(i);
		if (P.visible && P.estValide()) tracePoint(g,P);
	    }
	}
	else if (modeAffichage==2) {
	    // mode patron
	    // les faces
	    triFaces();
	    calcPyramide();
	    for (int i=0; i<faces.size(); i++) {
		f=(Face) faces.elementAt(i);
		if (f.visible && f.estValide() && f.type==Obj3d.iFace) traceFace(g,f,false);
		}
	    // les artes
	    for (int i=0; i<aretes.size(); i++) {
		S=(Segment3d)aretes.elementAt(i);
		traceSegmentCoupe(g,S);
	    }
	    // les points
	    //for (int i=0; i<points.size(); i++) {
	    //P=(Point3d) points.elementAt(i);
	    //if (P.visible && P.estValide()) tracePoint(g,P);
	    //}
	}
	else {
	    // mode convexe
	    for (int i=0; i<faces.size(); i++) {
		f=(Face) faces.elementAt(i);
		if (f.visible && f.estValide() && f.type==Obj3d.iFace) 
		    if (faceVue(f)) traceFace(g,f,true);
		}
	}
    }

    public void dessineFig(Graphics g) {
	if (img==null) img=createImage(R.largeur, R.hauteur);
	Graphics tcg=img.getGraphics();
	if (tcg!=null) {
	    traceFig(tcg);
	    g.drawImage(img,0,0,this);
	    tcg.dispose();
	}
    }

    /***
    public void traceDroite(Graphics g, Point3d P1, Point3d P2) {
	int[] c1, c2;
	double coeff,x0,y0,x1,y1;
	Color couleur;
	couleur=couleurDessin;
	c1=R.coordEcran(P1.x,P1.y,P1.z);
	c2=R.coordEcran(P2.x,P2.y,P2.z);
	if (c1[0]==c2[0]) {
	    //droite vecticale
	    c1[1]=R.hauteur;
	    c2[1]=0;
	}
	else {
	    //autres droites, on cherche les intersections avec les bords 
	    coeff=(1.0*(c2[1]-c1[1]))/(c2[0]-c1[0]);
	    y0=c1[1]-coeff*c1[0];
	    x0=(-y0)/coeff;
	    y1=coeff*R.largeur+y0;
	    x1=(R.hauteur-y0)/coeff;
	    if (x0>=0 && x0<=R.largeur) {
		c1[0]=(int)(x0+0.5); c1[1]=0; 
		if (x1>=0 && x1<=R.largeur) {
		    c2[0]=(int)(x1+0.5); c2[1]=R.hauteur;
		}
		else if (x1<0) {
		    c2[0]=0; c2[1]=(int)(y0+0.5);
		}
		else if (x1>R.largeur) {
		    c2[0]=R.largeur; c2[1]=(int)(y1+0.5);
		}
	    } 
	    else if (x0<0) {
		if (x1>=0 && x1<=R.largeur) {
		    c1[0]=0; c1[1]=(int)(y0+0.5); 
		    c2[0]=(int)(x1+0.5); c2[1]=R.hauteur;
		}
		else if (x1>R.largeur) {
		    c1[0]=0; c1[1]=(int)(y0+0.5);
		    c2[0]=R.largeur; c2[1]=(int)(y1+0.5);
		}
	    }
	    else if (x0>R.largeur) {
		if (y1>=0 && y1<=R.hauteur) {
		    c1[0]=R.largeur; c1[1]=(int)(y1+0.5);
		    c2[0]=(int)(x1+0.5); c2[1]=R.hauteur;
		}
	    }
	}
	if (!segmentVu(P1,P2)) couleur=couleurCache;
	g.setColor(couleur);
	g.drawLine(c1[0], c1[1], c2[0], c2[1]);
    }
    **/
}
