package jkb.geo3d;

public class Obj3d {
    public int type;
    public String nom;
    public int statut;
    public boolean visible;

    // indicateurs de statut
    public final static int stOk=0;
    public final static int stInterNonCoplanaire=1;
    public final static int stHorsSegment=2;
    public final static int stInterParallele=3;
    public final static int stDroitePointsConfondus=4;
    public final static int stHorsFace=5;

    public final static int stErreur=100;
 
    // indicateurs de type
    public final static int iPoint=100;
    public final static int iPointSur=101;
    public final static int iIntersection=102;
    public final static int iSegment=300;
    public final static int iDroite=301;
    public final static int iParallele=302;
    public final static int iFace=400;
    public final static int iPlan=401;
    public final static int iInconnu=500;

    public Obj3d(int numType) {
	type=numType;
	nom="";
	visible=true;
	statut=stOk;
	if (type==iInconnu) marqueErreur(stErreur);
    }

    public void marqueErreur(int code) {
	statut=code;
	visible=false;
    }

    public boolean estValide() {
	return (statut==stOk);
    }

    public boolean estPoint() {
	return (type>=iPoint && type<iSegment);
    }

    public boolean estSegment() {
	return (type>=iSegment && type<iFace);
    }

    public boolean estFace() {
	return (type>=iFace && type<iInconnu);
    }

    public String messageErreur() {
	switch (statut) {
	case stOk :
	    return "OK";
	case stInterNonCoplanaire :
	    return "Intersection de droites non coplanaires.";
	case stHorsSegment :
	    return "Point en dehors d'un segment.";
	case stInterParallele :
	    return "Intersection de droites parallles.";
	case stErreur :
	default :
	    return "Erreur inconnue.";
	}
    }

    public boolean coincide(Obj3d o) {
	return false;
    }

}
