package jkb.geo3d;

public class Repere {
    public double obsTheta, obsPhi;
    public double distEcran;
    public double echelle;
    public double dx, dy;
    public double xObs, yObs, zObs;
    public int largeur, hauteur;

    protected double sinTheta, sinPhi, cosTheta, cosPhi, cosThetaSinPhi, sinThetaSinPhi, 
	cosThetaCosPhi, sinThetaCosPhi;

    public Repere() {
	distEcran=500;
	echelle=1;
	setObsPhiObsTheta(20,20);
	largeur=0; hauteur=0;
	dx=0; dy=0;
    }

    public void recadre(int l, int h) {
	largeur=l; hauteur=h;
    }

    public void fixeEchelle(double r) {
	echelle=r;
    }

    public void deplace(double xx, double yy) {
	dx=dx+xx;
	dy=dy+yy;   
    }

    public void setObsPhiObsTheta(double valPhi, double valTheta) {
	double th,ph;
	obsPhi=valPhi;
	obsTheta=valTheta;
	th=Math.PI*obsTheta/180;
	ph=Math.PI*obsPhi/180;
	sinTheta=Math.sin(th);
	sinPhi=Math.sin(ph);
	cosTheta=Math.cos(th);
	cosPhi=Math.cos(ph);
	cosThetaSinPhi=cosTheta*sinPhi;
	sinThetaSinPhi=sinTheta*sinPhi;
	cosThetaCosPhi=cosTheta*cosPhi;
	sinThetaCosPhi=sinTheta*cosPhi;
	xObs=distEcran*cosThetaCosPhi;
	yObs=distEcran*sinThetaCosPhi;
	zObs=distEcran*sinPhi;
    }

    public final int[] coordEcran(double x, double y, double z) {
	int[] rep=new int[2];
	//double xX = (-x*sinTheta + y*cosTheta)*echelle;
	//double yY = (-x*cosThetaSinPhi - y*sinThetaSinPhi + z*cosPhi)*echelle;
	//rep[0] =(int) (largeur/2 + (distEcran*xX));
	//rep[1] =(int) (hauteur/2 - (distEcran*yY));
	//double zZ = (x*cosThetaCosPhi + y*sinThetaCosPhi + z*sinPhi);
	double coeff = echelle; //*distEcran/(distEcran - zZ);
	double xX = (-x*sinTheta + y*cosTheta)*coeff;
	double yY = (-x*cosThetaSinPhi - y*sinThetaSinPhi + z*cosPhi)*coeff;
	rep[0] =(int) (largeur/2 + xX + dx);
	rep[1] =(int) (hauteur/2 - yY + dy);

	return rep;
    }

    public double zVision(double x, double y, double z) {
	return x*cosThetaCosPhi+y*sinThetaCosPhi+z*sinPhi;
    }
}
