package jkb.geo3d;

public class Solide {

    public static void ajouteCube(String nom, double w, Fig3d f) {
        Point3d A=new Point3d(nom.substring(0,1),w,-w,-w);
	f.points.addElement(A);
        Point3d B=new Point3d(nom.substring(1,2),w,w,-w);
	f.points.addElement(B);
        Point3d C=new Point3d(nom.substring(2,3),-w,w,-w);
	f.points.addElement(C);
        Point3d D=new Point3d(nom.substring(3,4),-w,-w,-w);
	f.points.addElement(D);
        Point3d E=new Point3d(nom.substring(4,5),w,-w,w);
	f.points.addElement(E);
        Point3d F=new Point3d(nom.substring(5,6),w,w,w);
	f.points.addElement(F);
        Point3d G=new Point3d(nom.substring(6,7),-w,w,w);
	f.points.addElement(G);
        Point3d H=new Point3d(nom.substring(7,8),-w,-w,w);
	f.points.addElement(H);
	//faces
	f.faces.addElement(new Face(A,B,C,D));
	f.faces.addElement(new Face(B,C,G,F));
	f.faces.addElement(new Face(E,F,G,H));
	f.faces.addElement(new Face(A,D,H,E));
	f.faces.addElement(new Face(A,B,F,E));
	f.faces.addElement(new Face(D,C,G,H));
    }

    public static void ajouteTetraEdre(String nom, double w, Fig3d f) {
        Point3d A=new Point3d(nom.substring(0,1),-w,-w,w);
	f.points.addElement(A);
        Point3d B=new Point3d(nom.substring(1,2),w,-w,-w);
	f.points.addElement(B);
        Point3d C=new Point3d(nom.substring(2,3),-w,w,-w);
	f.points.addElement(C);
        Point3d D=new Point3d(nom.substring(3,4),w,w,w);
	f.points.addElement(D);
	//faces
	f.faces.addElement(new Face(A,B,C));
	f.faces.addElement(new Face(B,C,D));
	f.faces.addElement(new Face(A,B,D));
	f.faces.addElement(new Face(A,C,D));
    }

    public static void ajouteCoinCube(String nom, double w, Fig3d f) {
        Point3d A=new Point3d(nom.substring(0,1),-w,-w,w);
	f.points.addElement(A);
        Point3d B=new Point3d(nom.substring(1,2),-w,-w,-w);
	f.points.addElement(B);
        Point3d C=new Point3d(nom.substring(2,3),w,-w,-w);
	f.points.addElement(C);
	Point3d D=null;
	Point3d E=null;
	if (nom.length()==4) {
	    D=new Point3d(nom.substring(3,4),-w,w,-w);
	    f.points.addElement(D);
	}
	else {
	    D=new Point3d(nom.substring(3,4),w,w,-w);
	    f.points.addElement(D);
	    E=new Point3d(nom.substring(4,5),-w,w,-w);
	    f.points.addElement(E);
	}
	//faces
	if (E==null) {
	    f.faces.addElement(new Face(A,B,C));
	    f.faces.addElement(new Face(A,B,D));
	    f.faces.addElement(new Face(A,C,D));
	    f.faces.addElement(new Face(B,C,D));
	}
	else {
	    f.faces.addElement(new Face(A,B,C));
	    f.faces.addElement(new Face(A,B,E));
	    f.faces.addElement(new Face(A,C,D));
	    f.faces.addElement(new Face(A,D,E));
	    f.faces.addElement(new Face(B,C,D,E));
	}
    }

    public static void ajouteOctaEdre(String nom, double w, Fig3d f) {
        Point3d A=new Point3d(nom.substring(0,1),0,0,w);
	f.points.addElement(A);
        Point3d B=new Point3d(nom.substring(1,2),w,0,0);
	f.points.addElement(B);
        Point3d C=new Point3d(nom.substring(2,3),0,w,0);
	f.points.addElement(C);
        Point3d D=new Point3d(nom.substring(3,4),-w,0,0);
	f.points.addElement(D);
        Point3d E=new Point3d(nom.substring(4,5),0,-w,0);
	f.points.addElement(E);
        Point3d F=new Point3d(nom.substring(5,6),0,0,-w);
	f.points.addElement(F);
	//faces
	f.faces.addElement(new Face(A,B,C));
	f.faces.addElement(new Face(A,C,D));
	f.faces.addElement(new Face(A,D,E));
	f.faces.addElement(new Face(A,E,B));
	f.faces.addElement(new Face(F,B,C));
	f.faces.addElement(new Face(F,C,D));
	f.faces.addElement(new Face(F,D,E));
	f.faces.addElement(new Face(F,E,B));
    }

    public static void ajoutePyramide(String nom, double r, double h, Fig3d f) {
        Point3d A=new Point3d(nom.substring(0,1),0,0,h/2);
	f.points.addElement(A);
	int n=nom.length()-1;
	Point3d[] base;
	Face face;
	double a=0;
	base=new Point3d[n];
	for (int i=0; i<n; i++) {
	    a=2*i*Math.PI/n;
	    base[i]=new Point3d(nom.substring(i+1,i+2),r*Math.cos(a),r*Math.sin(a),-h/2);
	    f.points.addElement(base[i]);
	}
	for (int i=0; i<n-1; i++) {
	    f.faces.addElement(new Face(A,base[i],base[i+1]));
	}
	f.faces.addElement(new Face(A,base[n-1],base[0]));
	face=new Face();
	for (int i=0; i<n; i++) face.sommets.addElement(base[i]);
	f.faces.addElement(face);
    }

    public static void ajoutePrisme(String nom, double r, double h, Fig3d f) {
	int n=nom.length()/2;
	Point3d[] base1,base2;
	Face f1,f2;
	double a=0;
	base1=new Point3d[n];
	for (int i=0; i<n; i++) {
	    a=2*i*Math.PI/n;
	    base1[i]=new Point3d(nom.substring(i,i+1),r*Math.cos(a),r*Math.sin(a),-h/2);
	    f.points.addElement(base1[i]);
	}
	base2=new Point3d[n];
	for (int i=0; i<n; i++) {
	    a=2*i*Math.PI/n;
	    base2[i]=new Point3d(nom.substring(i+n,i+n+1),r*Math.cos(a),r*Math.sin(a),h/2);
	    f.points.addElement(base2[i]);
	}
	f1=new Face();
	for (int i=0; i<n; i++) f1.sommets.addElement(base1[i]);
	f.faces.addElement(f1);
	f2=new Face();
	for (int i=0; i<n; i++) f2.sommets.addElement(base2[i]);
	f.faces.addElement(f2);
	for (int i=0; i<n-1; i++) {
	    f.faces.addElement(new Face(base1[i],base2[i],base2[i+1],base1[i+1]));
	}
	f.faces.addElement(new Face(base1[n-1],base2[n-1],base2[0],base1[0]));
    }

    public static void ajoutePavedroit(String nom, double l, double p, double h, Fig3d f) {
        Point3d A=new Point3d(nom.substring(0,1),l/2,-p/2,-h/2);
	f.points.addElement(A);
        Point3d B=new Point3d(nom.substring(1,2),l/2,p/2,-h/2);
	f.points.addElement(B);
        Point3d C=new Point3d(nom.substring(2,3),-l/2,p/2,-h/2);
	f.points.addElement(C);
        Point3d D=new Point3d(nom.substring(3,4),-l/2,-p/2,-h/2);
	f.points.addElement(D);
        Point3d E=new Point3d(nom.substring(4,5),l/2,-p/2,h/2);
	f.points.addElement(E);
        Point3d F=new Point3d(nom.substring(5,6),l/2,p/2,h/2);
	f.points.addElement(F);
        Point3d G=new Point3d(nom.substring(6,7),-l/2,p/2,h/2);
	f.points.addElement(G);
        Point3d H=new Point3d(nom.substring(7,8),-l/2,-p/2,h/2);
	f.points.addElement(H);
	//faces
	f.faces.addElement(new Face(A,B,C,D));
	f.faces.addElement(new Face(B,C,G,F));
	f.faces.addElement(new Face(E,F,G,H));
	f.faces.addElement(new Face(A,D,H,E));
	f.faces.addElement(new Face(A,B,F,E));
	f.faces.addElement(new Face(D,C,G,H));
    }

}
