/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * PlanCourbe.java
 * JDK 1.1  
 * Version 1.1 Rvision 03/06/2000
 * Partie du package jkb.geom permettant de reprsenter
 * graphiquement des courbes donnes par une quation cartsienne,
 * paramtrique ou polaire.
 *
 */

package jkb.geom;

import java.util.Hashtable;
import java.util.Vector;
import java.awt.*;
import java.awt.event.*;
import jkb.utils.*;
import jkb.calkul.*;

/**
 * Classe drive de Canvas destine  tracer des courbes.
 */
public class PlanCourbe extends jkb.geom.Plan 
 implements MouseListener,MouseMotionListener  {

/**
 * Gestion de la souris
 */
 public boolean optMobile;
 protected int xSouris;
 protected int ySouris;

 /**
  * Dfinition des fonctions utilisables
  */
 public Hashtable dico=null; 
 
 /**
  * Ensemble des courbes  dessiner
  */
 public Vector courbes=null;
 
 /**
  * Pour forcer un repre orthonormal
  */
 public boolean optionOrtho=true;
 
 /**
  * Constructeur pour une zone par dfaut de 200x200
  */
 public PlanCourbe() {
  super();
  addMouseListener(this);
  addMouseMotionListener(this);
  courbes = new Vector();
  dico = new Hashtable();
  MathNode.initDico(dico);
  xSouris = -1;
  ySouris = -1;
  optMobile = true;
  optQuadrillage = true;
  optAxes = true;
 }
 
 /**
  * Ajout d'une courbe  dessiner
  */
 public void ajouteCourbe(String S) {
  Courbe c=new Courbe(S,dico);
  courbes.addElement(c);
 }

 public void ajouteCourbe(String S, String couleur) {
  Courbe c=new Courbe(S,dico);
  c.fixeCouleur(couleur);
  courbes.addElement(c);
 }
 
 /**
  * Remise  zro
  */
 public void effaceTout() {
  courbes.removeAllElements();
 }
 
 /**
  * Dessin des courbes
  */
 public void paint(Graphics g) {
  Courbe c;
  if (optionOrtho) {
   fenetreOrthoCentre(unX);
   optionOrtho=false;
  }
  else fenetre(xMin(),xMax(),yMin(),yMax());
  Graphics gg=donneCG();
  dessineFond(gg);
  for (int i=0; i<courbes.size(); i++) {
   c=(Courbe)courbes.elementAt(i);
   c.trace(gg,this,dico);
  }
  gg.dispose();
  super.paint(g);
 }

 // Gestion des vnements souris
 public void mouseReleased(MouseEvent e) {}

 public void mousePressed(MouseEvent e) {
  xSouris=e.getX();
  ySouris=e.getY();
 }

 public void mouseEntered(MouseEvent e) {}

 public void mouseExited(MouseEvent e) {}

 public void mouseClicked(MouseEvent e) {}

 public void mouseDragged(MouseEvent e) {
  //vrifier que la souris est dans la zone
  if (contains(e.getX(),e.getY()) && optMobile) {
   int xs=e.getX();
   int ys=e.getY();
   optionOrtho=false;
   double xdep=(xs-xSouris)*unPixelX();
   double ydep=(ys-ySouris)*unPixelY();
   fenetreOrtho(unX,xMin()-xdep,yMin()+ydep);
   xSouris=xs;
   ySouris=ys;
   repaint();
  } 
 }

 public void mouseMoved(MouseEvent e) {}
 
}

