/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * Cercle.java
 * JDK 1.1  
 * Version 1.2 Rvision 01/08/2000
 * Partie du package imageo fournissant l'objet cercle.
 *
 */

package jkb.imageo;

import java.util.Vector;
import jkb.geom.GeoCalc;

/**
 * Classe reprsentant un cercle imageo.
 * Utiliser les fonctions Init---- pour prciser
 * le mode de dfinition.
 */
public class Cercle extends ObjImageo {
 
 /**
  * Initialisation du cercle en donnant le centre puis :
  * - un point du cercle
  * - le rayon du cercle
  * - ou deux points dont la distance dfini le rayon.
  */
 public Cercle(Vector V) {
  super(iCercle);
  if ("PP".equals(V.elementAt(V.size()-1))) {
   objs[1]=(ObjImageo)V.elementAt(0);
   objs[2]=(ObjImageo)V.elementAt(1);
   stInitOk=true;
   oType=iCercle2;   
  }
  else if ("PN".equals(V.elementAt(V.size()-1))) {
   objs[1]=(ObjImageo)V.elementAt(0);
   double r=((Double)V.elementAt(1)).doubleValue();
   datas[2]=Math.abs(r);
   stInitOk=true;
   oType=iCercle1;
  }
  else if ("PPP".equals(V.elementAt(V.size()-1))) {
   objs[1]=(ObjImageo)V.elementAt(0);
   objs[2]=(ObjImageo)V.elementAt(1);
   objs[3]=(ObjImageo)V.elementAt(2);
   stInitOk=true;
   oType=iCercle3;
  }
  else stInitOk=false;
 }

 /**
  * Calcul du centre et du rayon du cercle.
  */
 public void calcDatas() {
  if (stInitOk && objs[1].estValide()) { 
   datas[0]=objs[1].donneX();
   datas[1]=objs[1].donneY();
   stCalcOk=true;
   if (oType==iCercle2) {
    if (stInitOk && objs[2].estValide()) {
     datas[2]=GeoCalc.dist(objs[1].donneX(),objs[1].donneY(),
                           objs[2].donneX(),objs[2].donneY());
    }
    else stCalcOk=false;
   }
   else if (oType==iCercle3) {
    if (stInitOk && objs[2].estValide() && objs[3].estValide()) {
     datas[2]=GeoCalc.dist(objs[2].donneX(),objs[2].donneY(),
                           objs[3].donneX(),objs[3].donneY());
    }
    else stCalcOk=false;
   }
  }
  else stCalcOk=false;
 }
 
} 

