/*
 * Copyright (c) 1999 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * ConstImageo.java
 * JDK 1.1  
 * Version 1.1 Rvision 28/12/1999
 * Partie du package imageo fournissant un composant 
 * contenant une figure dfinissable par un script, et
 * permettant une construction par tapes.
 *
 */

package jkb.imageo;

import java.util.*;
import java.awt.*;
import java.io.*;
import java.net.*;

/**
 * Classe reprsentant un composant contenant une figure imageo
 * dfinissable par un script.
 */
public class ConstImageo extends PlanImageo {
 
 public int etapeCourante;
 public Vector etapes;
 public Vector comments;
 
 public ConstImageo() {
  super();
  etapeCourante=0;
  etapes=new Vector(10,10);
  comments=new Vector(10,10);
 }
 
 public String donneScript(int n) {
  String S;
  if (n<etapes.size()) S=(String)etapes.elementAt(n);
  else S="Erreur";
  return S;
 }
 
 public String donneInfo(int n) {
  String S;
  if (n<comments.size()) S=(String)comments.elementAt(n);
  else S="Erreur";
  return S;
 }
 
 public void lireFichierConst(URL source) {
  String CStr="";
  String FStr="";
  Fig.vider();
  comments.removeAllElements();
  etapes.removeAllElements();
  try {
   String aLine = "";
   BufferedReader br = new BufferedReader
          (new InputStreamReader(source.openStream()));
   while (null != (aLine = br.readLine())) {
    //aline contient la ligne courante
    if (aLine.startsWith("#")) {
     if (FStr.length()>0) etapes.addElement(FStr);
     FStr="";
     CStr=CStr+aLine.substring(1)+'\n';
    }
    else {
     if (CStr.length()>0) comments.addElement(CStr);
     CStr="";
     if (aLine.length()>0 && !aLine.startsWith(";"))
      FStr=FStr+aLine+'\n';
    }  
   } 
   br.close();
   if (FStr.length()>0) etapes.addElement(FStr);
  }
  catch(Exception e) {
   e.printStackTrace();
  }
 }
 
 public int nombreEtapes() {
  return etapes.size();
 }
 
 public void fixeEtape(int n) {
  String NS="";
  ScriptImageo scr;
  if (n<0) etapeCourante=0;
  else if (n>=nombreEtapes()) etapeCourante=nombreEtapes()-1;
  else etapeCourante=n;
  Fig.vider();
  for (int i=0; i<=etapeCourante; i++) NS=NS+donneScript(i);
  scr=new ScriptImageo(NS);
  Fig=scr.compile();
  repaint();
 }
 
} 
