/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * ObjImageo.java
 * JDK 1.1  
 * Version 1.2 Rvision 01/08/2000
 * Partie du package imageo fournissant un objet gomtrique
 * gnrique.
 *
 */

package jkb.imageo;

/**
 * Classe reprsentant un objet gomtrique gnrique pour
 * le package imageo.
 */
public class ObjImageo {

 // indicateurs de type
 public final static int iPoint=100;
 public final static int iMilieu=iPoint+1;
 
 public final static int iSymetrique=iPoint+10;
 public final static int iSymPoint=iSymetrique+1;
 public final static int iSymAxe=iSymetrique+2;
 public final static int iProjection=iSymetrique+3;
 public final static int iTranslation=iSymetrique+4;
 public final static int iRotation=iSymetrique+5;
 public final static int iHomothetie=iSymetrique+6;

 public final static int iPointSur=iPoint+20;
 public final static int iPointSurDroite=iPointSur+1;
 public final static int iPointSurCercle=iPointSur+2;
 
 public final static int iIntersection=iPoint+30;
 public final static int iInterDD=iIntersection+1;
 public final static int iInterCC=iIntersection+2;
 public final static int iInterDC=iIntersection+3;
 
 public final static int iMesure=200;
 public final static int iMesureSegment=iMesure+1;
 public final static int iMesureAngle=iMesure+2;
 
 public final static int iDroite=300;
 public final static int iParallele=iDroite+1;
 public final static int iPerpendiculaire=iDroite+2;
 public final static int iMediatrice=iDroite+3;
 public final static int iBissectrice=iDroite+4;
 
 public final static int iSegment=400;
 
 public final static int iDemiDroite=500;
 
 public final static int iCercle=600;
 public final static int iCercle1=iCercle+1;
 public final static int iCercle2=iCercle+2;
 public final static int iCercle3=iCercle+3;
 
 // indicateurs du statut de l'objet.
 public boolean stInitOk;
 public boolean stCalcOk;
 public boolean stVisible;
 public boolean stMobile;
 public boolean stChoisi;
 public boolean stTrace;
 public boolean stPointille;
 public boolean stEpais;

 /**
  * Nom de l'objet.
  */
 String nom;
 
 /**
  * Indicateur du type : point, segment, droite, ...
  */
 public int oType;
 
 /**
  * Tableau contenant les donnes ncessaires  l'affichage.
  * Il est mis  jour par la fonction CalcDatas. 
  */
 protected double[] datas = new double[3];

 /**
  * Tableau contenant les objets dont dpend l'objet.
  */
 protected ObjImageo[] objs = new ObjImageo[4];                  //objets servant  la construction
 
 /**
  * Constructeur de l'objet gomtrique gnrique.
  */
 public ObjImageo(int t) {
  int i;
  nom="";
  oType=t;
  stInitOk=false;
  stCalcOk=false;
  stVisible=true;
  stMobile=false;
  stChoisi=false;
  stTrace=false;
  stPointille=false;
  stEpais=false;
  for (i=0; i<3; i++) datas[i]=0.0;
  for (i=0; i<4; i++) objs[i]=null;
 }
 
 /**
  * Calcul des donnes d'affichage et stockage dans datas.
  */
 public void calcDatas() {
  stCalcOk=false;
 }

 /**
  * Renvoie le premier lment de datas.
  */
 public final double donneX() {
  return datas[0];
 }

 /**
  * Renvoie le deuxime lment de datas.
  */
 public final double donneY() {
  return datas[1];
 }

 /**
  * Renvoie le premier lment de datas.
  */
 public final double donneA() {
  return datas[0];
 }

 /**
  * Renvoie le deuxime lment de datas.
  */
 public final double donneB() {
  return datas[1];
 }

 /**
  * Renvoie le troisime lment de datas.
  */
 public final double donneC() {
  return datas[2];
 }

 /**
  * Renvoie le troisime lment de datas.
  */
 public final double donneR() {
  return datas[2];
 }

 /**
  * Renvoie le type : point, segment, cercle, droite
  */
 public int donneType() {
  return (oType/100)*100;
 }
 
 /**
  * Indique que l'objet est valide : initialisation et calcul
  * des donnes d'affichage russis.
  */
 public final boolean estValide() {
  return (stInitOk & stCalcOk);
 } 

 
}

