/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * Segment.java
 * JDK 1.1  
 * Version 1.2 Rvision 01/08/2000
 * Partie du package imageo fournissant l'objet segment.
 *
 */

package jkb.imageo;

import java.util.Vector;
import jkb.geom.GeoCalc;


/**
 * Classe reprsentant l'objet segment imageo.
 */
public class Segment extends ObjImageo {
 
 public Segment(int typ) {
  super(typ);
 }
 
 /**
  * Initialise le segment en fixant ses extrmits.
  */
 public Segment(jkb.imageo.Point P1, jkb.imageo.Point P2) {
  super(iSegment);
  objs[1]=P1;
  objs[2]=P2;   
  stInitOk=true;
 }
 
 /**
  * Initialise le segment en fixant ses extrmits.
  */
 public Segment(Vector V) {
  super(iSegment);
  if ("PP".equals(V.elementAt(V.size()-1))) {
   objs[1]=(ObjImageo)V.elementAt(0);
   objs[2]=(ObjImageo)V.elementAt(1);   
   stInitOk=true;
  } 
  else stInitOk=false; 
 }

 /**
  * Calcule les donnes d'affichage : il s'agit des coefficients
  * a, b et c de l'quation de la droite prolongeant le segment.
  */
 public void calcDatas() {
  if (stInitOk && objs[1].estValide() && objs[2].estValide()) { 
   datas[0]=objs[2].donneY()-objs[1].donneY();
   datas[1]=objs[1].donneX()-objs[2].donneX();
   datas[2]=-objs[1].donneX()*objs[2].donneY()+objs[2].donneX()*objs[1].donneY();
   if (GeoCalc.estNul(datas[0]) && GeoCalc.estNul(datas[1])) {
    stCalcOk=false;
   }
   else stCalcOk=true;
  }
  else stCalcOk=false;
 }

} 

