/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * LogoStr.java
 * JDK 1.1  
 * Version 1.1 Rvision 03/06/2000
 * Classe du package jkb.mlogo reprsentant une chaine de 
 * commandes Logo  analyser.
 *
 */

package jkb.mlogo;

import java.util.Vector;
import java.util.Hashtable;
import java.awt.*;
import jkb.calkul.*;
import jkb.utils.DicoObj;

/**
 * Classe reprsentant une commande Logo pour la tortue.
 */
public class LogoStr extends BoolStr {

 public static String logoCars="[]";
 
 public final static int errMotAttendu=20;
 public final static int errMotInconnu=21;
 public final static int errCompil=22;
 
 public LogoStr(String S) {
  super(S,logoCars);
 }
 

 public String messageErreur() {
  String rep="";
  switch (codeErreur) {
   case errMotAttendu :
    rep="Identificateur attendu."+posErreur();
    break;
   case errMotInconnu :
    rep="Commande inconnue."+posErreur();
    break;
   case errCompil :
    rep="Erreur de compilation."+posErreur();
    break;
   default :
    rep=super.messageErreur();
  }
  return rep;
 }
 
 /**
  * Transforme une chane de caractres en une suite de commandes
  * Logo
  **/
 public Vector compile(Hashtable dico) {
  String mot;
  MathNode form;
  Vector tmpV,prg;
  DicoObj dobj;
  Vector V=new Vector();
  passeEspaces();
  // dterminer le point d'arrt
  char stop=MathStr.carFin;
  if (suivant=='(') {
   stop=')'; lireSuivant(); passeEspaces();
  } 
  else if (suivant=='[') {
   stop=']'; lireSuivant(); passeEspaces();
  } 
  // lire et interprter
  while ((suivant!=stop) && (codeErreur==0)) {
   passeEspaces(); 
   mot=motCourant; // la commande  excuter
   if (mot.length()==0) {
    marqueErreur(errMotAttendu);
    return null;
   }
   // trouver la commande
   dobj=(DicoObj)dico.get(mot.toUpperCase());
   if (dobj==null) {
    marqueErreur(errMotInconnu);
    return null;
   }
   else {
    lireSuivant();  // prparer lecture arguments
    passeEspaces();
    switch (dobj.oType) {
     case LogoCom.lgDANS :
      // lire le nom de la variable
      mot=motCourant;
      if (mot.length()==0) {
       marqueErreur(errMotAttendu);
       return null;
      }
      lireSuivant();
      passeEspaces();
      if (suivant=='"') {
       lireSuivant();
       form=evalExp(dico,false);
       if (form==null) return null;
       if (suivant=='"') lireSuivant();
       passeEspaces();
       MathNode.defForm(mot.toUpperCase(),form,dico);
      }
      else {
       // lire le contenu de la variable
       form=evalExp(dico,false);
       if (form==null) return null;
       passeEspaces();
       // mettre  jour le dictionnaire
       MathNode.defVar(mot.toUpperCase(),form.donneValeur(),dico);
       // ajouter la commande au programme
       tmpV=new Vector(2);
       tmpV.addElement(mot.toUpperCase());
       tmpV.addElement(form);
       V.addElement(new LogoCom(LogoCom.lgDANS,tmpV));
      } 
      break;
     case LogoCom.lgPour : 
      // lire le nom de la procdure
      mot=motCourant;
      if (mot.length()==0) {
       marqueErreur(errMotAttendu);
       return null;
      }
      lireSuivant();
      passeEspaces();
      // lire les instructions formant la procdure
      prg=compile(dico);
      if (prg!=null) {
       passeEspaces();
       // ajouter la commande au dictionnaire
       dico.put(mot.toUpperCase(),new LogoCom(LogoCom.lgProc,prg));
      }
      else return null;
      break;
     case LogoCom.lgProc :
      // commande ajoute au dictionnaire par POUR
      V.addElement(new LogoCom(LogoCom.lgPROG,(Vector)dobj.obj));
      break;
     case LogoCom.lgAFF :
      // affichage de texte ou de nombres
      tmpV=new Vector();
      if (suivant=='(') {
       do {
        lireSuivant();
        passeEspaces();
        if (suivant=='"') {
         mot=lireChaine();
         passeEspaces();
         tmpV.addElement(new DicoObj(0,mot));
        }
        else {
         form=evalExp(dico,false);
         passeEspaces();
         tmpV.addElement(new DicoObj(1,form));
        }
       } while (suivant==',');
       V.addElement(new LogoCom(LogoCom.lgAFF,tmpV));
       if (suivant==')') lireSuivant();  //parenthse fermante
       else marqueErreur(errParaFonc);
       passeEspaces();
      }      
      else if (suivant=='"') {
       mot=lireChaine();
       passeEspaces();
       tmpV.addElement(new DicoObj(0,mot));
       V.addElement(new LogoCom(LogoCom.lgAFF,tmpV));
      }
      else {
       form=evalExp(dico,false);
       passeEspaces();
       tmpV.addElement(new DicoObj(1,form));
       V.addElement(new LogoCom(LogoCom.lgAFF,tmpV));
      }
      break;
     default :
      // cas gnral : on utilise la chane des types 
      if (dobj.obj==null) {
       // pas de paramtres
       V.addElement(new LogoCom(dobj.oType,null));
      }
      else {
       // nombre de paramtres
       int l=((String)dobj.obj).length();
       // prparer le vecteur contenant les paramtres
       tmpV=new Vector(l);
       // lecture des paramtres
       for (int i=0; i<l; i++) {
        char c=((String)dobj.obj).charAt(i);
        if (c=='N') {
         // param. numrique
         form=evalExp(dico,false);
         if (form==null) return null;
         passeEspaces();
         tmpV.addElement(form);
        }
        else if (c=='M') {
         // param. mot
         mot=motCourant;
         if (mot.length()==0) {
          marqueErreur(errMotAttendu);
          return null;
         }
         lireSuivant();
         passeEspaces();
         tmpV.addElement(mot.toUpperCase());
        }
        else if (c=='C') {
         // param. chaine
         mot=lireChaine();
         passeEspaces();
         tmpV.addElement(mot);
        } 
        else if (c=='P') {
         // param. procdure
         prg=compile(dico);
         if (prg!=null) {
          passeEspaces();
          tmpV.addElement(prg);
         }
         else return null;
        }
        else if (c=='B') {
         // expression boolenne
         form=evalBoolItem(dico,false);
         if (form==null) return null;
         passeEspaces();
         tmpV.addElement(form);
        }
        else marqueErreur(errCompil);
       }
       if (codeErreur==0) V.addElement(new LogoCom(dobj.oType,tmpV));
      }
    } // fin switch
   } // DO!=null
   passeEspaces();
  } // fin while
  if (codeErreur!=0) return null;
  passeEspaces();
  //lire caractre de fin
  lireSuivant();
  passeEspaces();
  return V;
 }

}

