/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * LogoCom.java
 * JDK 1.1  
 * Version 1.1 Rvision 03/06/2000
 * Classe du package jkb.mlogo reprsentant une commande Logo.
 *
 */

package jkb.mlogo;

import java.util.Vector;
import java.util.Hashtable;
import jkb.calkul.MathNode;
import jkb.utils.DicoObj;

/**
 * Classe reprsentant une commande Logo pour la tortue.
 */
public class LogoCom extends DicoObj {

 // codes pour DicoObj
 public final static int lgCom=500;
 public final static int lgProc=lgCom+1;
 public final static int lgPour=lgCom+2;  
 // codes des commandes Logo
 public final static int lgREPETE=lgCom+3;
 public final static int lgPROG=lgCom+4;
 public final static int lgDANS=lgCom+5;
 public final static int lgSI=lgCom+6;
 public final static int lgTANTQUE=lgCom+7;
 public final static int lgAFF=lgCom+8;
 public final static int lgAFFN=lgCom+9;
 public final static int lgRET=lgCom+10;
 public final static int lgMaxCom=lgCom+11;
 
 public LogoCom(int c, Vector o) {
  super(c,o);
 }

 /*
  * Construction du dictionnaire de base MiniLogo
  * La chane indique le nombre et le type des paramtres  lire lors
  * de la compilation.
  * N pour nombre
  * M pour mot
  * C pour chane
  * P pour procdure
  * B pour expression boolenne
  */
 public static void initDicoLogo(Hashtable dico) {
  dico.put("REPETE",new DicoObj(lgREPETE,"NP"));
  dico.put("FAIRE",new DicoObj(lgREPETE,"NP"));
  dico.put("POUR",new DicoObj(lgPour,null));
  dico.put("DANS",new DicoObj(lgDANS,null));
  dico.put("SI",new DicoObj(lgSI,"BP"));
  dico.put("TANTQUE",new DicoObj(lgTANTQUE,"BP"));
  dico.put("AFF",new DicoObj(lgAFF,null));
  dico.put("RET",new DicoObj(lgRET,null));
  dico.put("VRAI",new MathNode(1.0));
  dico.put("FAUX",new MathNode(0.0));
 }
 
 public double lireNombre(int n, int mAngle) {
  Vector objs=(Vector)obj;
  int ma=MathNode.modeAngle;
  MathNode.modeAngle=mAngle;
  double d=((MathNode)objs.elementAt(n)).donneValeur();
  MathNode.modeAngle=ma;
  return d;
 }
 
 public Vector lireProg(int n) {
  Vector objs=(Vector)obj;
  return (Vector)objs.elementAt(n);
 }
 
 public String lireChaine(int n) {
  Vector objs=(Vector)obj;
  return (String)objs.elementAt(n);
 }

} 

