/*
 * Copyright (c) 1999 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * Div.java
 * JDK 1.1  
 * Version 1.1 Rvision 20/06/2000
 * Partie du package jkb fournissant diverses fonctions statiques 
 * plus ou moins utiles.
 *
 */

package jkb.utils;

import java.awt.*;

public class Div {

    public static double zero=0.00000001;

    public static void bip() {
	Toolkit.getDefaultToolkit().beep(); 
    }
 
    /**
     * Transformation d'un nombre de type double (d) en chane de
     * caractres avec un nombre fix (dec) de dcimales.
     */ 
    public final static String DoubleToStr(double d, int dec) {
	String S="";
	int c=1;
	int k=1;
	while (k<=dec) {
	    c=c*10;
	    k++;
	} 
	Double dd=new Double(Math.round(d*c)/(1.0*c));
	S=dd.toString();
	// suppression du .0 renvoy pour les entiers
	if (S.endsWith(".0")) S=S.substring(0,S.length()-2);
	return S;
    }

    public final static boolean errCalc(double d) {
	//indique si d est bien un nombre
	return (Double.isNaN(d) || Double.isInfinite(d));
    }
 
    public final static double det(double a1, double b1, double a2, double b2) {
	return a1*b2-a2*b1;
    }

    // rsolution du systme a1x+b1y=c1; a2x+b2y=c2
    // renvoi un tableau des deux nombres solutions ou null dans les autres cas
    public final static double[] syseq2x2(double a1, double b1, double c1, 
                                          double a2, double b2, double c2) {
	double[] rep = null;
	double delta=det(a1,b1,a2,b2);
	if (Math.abs(delta)>zero) {
	    rep=new double[2];
	    rep[0]=det(c1,b1,c2,b2)/delta;
	    rep[1]=det(a1,c1,a2,c2)/delta;
	}
	return rep;
    }
}

