/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * montec.java
 * JDK 1.1  
 * Version 1.1 Rvision 03/06/2000
 * Applet permettant d'valuer des aires en tirant des points au
 * hasard.
 *
 */

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import jkb.calkul.*;
import jkb.utils.*;
import jkb.geom.*;

public class montec extends Applet implements ActionListener {
 Plan zoneDessin;
 Label zoneInfo;
 Hashtable dico;
 Courbe c;
 int nbPoints;
 int nbPointsInterieurs;
 
 public void init() {
  dico=new Hashtable();
  MathNode.initDico(dico);
  c=null;
  setLayout(new BorderLayout());
  zoneDessin=new PlanGradu();
  zoneDessin.optAxes=true;
  zoneDessin.optQuadrillage=false;
  Panel pan=new Panel();
  Button but=new Button("Tirages");
  but.addActionListener(this);
  pan.add(but);
  but=new Button("Recommencer");
  but.addActionListener(this);
  pan.add(but);
  add("Center",zoneDessin);
  add("South",pan);
  zoneInfo=new Label();
  add("North",zoneInfo);
 }
 
 public void start() {
  String comstr=getParameter("courbe");
  if (comstr!=null) c=new Courbe(comstr,dico);
  else c=new Courbe("y=1/(1+x)",dico);
  c.autoLimite=false;
  c.tMini=0; c.tMaxi=1; c.nombrePoints=50;
  initDessin();
 }

 void initDessin() {
  nbPoints=0;
  nbPointsInterieurs=0;
  zoneInfo.setText("Mthode de Monte Carlo");
  Graphics g=zoneDessin.donneCG();
  zoneDessin.fenetre(-0.25,1.25,-0.25,1.25);
  zoneDessin.dessineFond(g);
  c.trace(g,zoneDessin,dico);
  zoneDessin.traceVers(g,0,0,0);
  zoneDessin.traceVers(g,0,1,1);
  zoneDessin.traceVers(g,1,1,1);
  zoneDessin.traceVers(g,1,0,1);
  g.dispose();
  zoneDessin.repaint();
 } 

 public void actionPerformed(ActionEvent evt) {
  if (evt.getActionCommand().equals("Tirages")) tirages();
  else if (evt.getActionCommand().equals("Recommencer")) initDessin();
 }
 
 double calcY(double x) {
  MathNode.defVar("X",x,dico);
  return c.f1.donneValeur();
 }
 
 public void tirages() {
  double x,y,yy;
  Graphics g=zoneDessin.donneCG();
  for (int i=0; i<1000; i++) {
   x=Math.random();
   y=Math.random();
   yy=calcY(x);
   nbPoints++;
   if (y<=yy) { 
    nbPointsInterieurs++;
    g.setColor(Color.red);
   }
   else g.setColor(Color.blue);
   zoneDessin.traceVers(g,x,y,0);
   zoneDessin.traceVers(g,x,y,1);
  }
  g.dispose();
  zoneDessin.repaint();
  x=(double)nbPointsInterieurs/(double)nbPoints;
  String S="Total : "+nbPoints+" Proportion : "+Div.DoubleToStr(x,4);
  zoneInfo.setText(S);
 }
 
 
}

