/*
 * Copyright (c) 2000-2001 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * peano.java
 * JDK 1.1 
 * Version 1.2 Rvision 05/01/2001
 * Applet permettant d'afficher la courbe de remplissage
 * de Peano 
 *
 */

import java.util.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;


public class peano extends Applet 
 implements ActionListener {

 // l'applet contient une zone de dessin et une zone  boutons de
 // commandes
 
 PeanoView View;
 
 public void init() {
  String nomf;
  Button bouton;
  View=new PeanoView();
  setBackground(Color.white);
  setLayout(new BorderLayout());
  add("South",DoButtonPanel());
  add("Center",View);
 }

 public void start() {
  View.init();
 }
 
 Panel DoButtonPanel() {
  Button bouton;
  Panel pan=new Panel();
  pan.setLayout(new FlowLayout());
  bouton=new Button("Dpart");
  bouton.addActionListener(this);
  pan.add(bouton);
  bouton=new Button("Suivant");
  bouton.addActionListener(this);
  pan.add(bouton);
  bouton=new Button("Prcdent");
  bouton.addActionListener(this);
  pan.add(bouton);
  pan.setBackground(Color.lightGray);
  return pan;
 }

 public void actionPerformed(ActionEvent evt) {
  if (evt.getActionCommand().equals("Suivant")) {
   View.Suivant();
  }
  else if (evt.getActionCommand().equals("Prcdent")) {
   View.Precedent();
  }
  else if (evt.getActionCommand().equals("Dpart")) {
   View.Ordre=0;
   View.repaint();
  } 
 }
}

class PeanoView extends Canvas {

 int xc,yc;        //point courant
 int un=1;         // 
 int cote;         //ct du carr
 int Ordre=0;      //nombre d'itrations
 int MaxIter=0;    //maximum d'itrations
 
 //calcul des donnes initiales
 void init() {
  int cot=Math.min(getSize().width,getSize().height);
  int tmp=1;
  while (tmp<=cot) {
   tmp=tmp*2;
  } 
  cote=tmp/2;
  MaxIter=-1;
  un=cote;
  while (un>=2) {
   un=un/2; MaxIter++;
  }
 }
 
 void bouge(Graphics g, int dx, int dy) {
  int nx=xc+un*dx;
  int ny=yc+un*dy;
  g.drawLine(xc,yc,nx,ny);
  xc=nx; yc=ny;
 }
 
 void base(Graphics g, int i) {
  switch (i) {
   case 0 :
    bouge(g,1,0); bouge(g,0,1); bouge(g,-1,0);
    break;
   case 1 :
    bouge(g,0,1); bouge(g,1,0); bouge(g,0,-1);
    break;
   case 2 :
    bouge(g,0,-1); bouge(g,-1,0); bouge(g,0,1);
    break;
   case 3 :
    bouge(g,-1,0); bouge(g,0,-1); bouge(g,1,0);
    break;
  }
 }

 public void figure(Graphics g, int i, int n) {
  if (n==0) base(g,i);
  else {
   switch (i) {
    case 0:
     figure(g,1,n-1); bouge(g,1,0);
     figure(g,0,n-1); bouge(g,0,1);
     figure(g,0,n-1); bouge(g,-1,0);
     figure(g,2,n-1);
     break;
    case 1:
     figure(g,0,n-1); bouge(g,0,1);
     figure(g,1,n-1); bouge(g,1,0);
     figure(g,1,n-1); bouge(g,0,-1);
     figure(g,3,n-1);
     break;
    case 2:
     figure(g,3,n-1); bouge(g,0,-1);
     figure(g,2,n-1); bouge(g,-1,0);
     figure(g,2,n-1); bouge(g,0,1);
     figure(g,0,n-1);
     break;
    case 3:
     figure(g,2,n-1); bouge(g,-1,0);
     figure(g,3,n-1); bouge(g,0,-1);
     figure(g,3,n-1); bouge(g,1,0);
     figure(g,1,n-1);
     break;
   }
  }
 }
 
 public void paint(Graphics g) {
  g.setColor(Color.black);
  un=cote/2;
  for (int i=0; i<Ordre; i++) un=un/2;
  xc=(getSize().width-cote)/2+un/2; 
  yc=(getSize().height-cote)/2+un/2;
  figure(g,0,Ordre);
 }
 
 void Suivant() {
  if (Ordre<MaxIter) {
   Ordre++;
   repaint();
  } 
 }
 
 void Precedent() {
  if (Ordre>0) {
   Ordre--;
   repaint();
  } 
 }

}

