/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * traceur.java
 * JDK 1.1  
 * Version 1.1 Rvision 03/06/2000
 * Applet permettant de tracer des courbes dfinies par des quations
 * cartsiennes, polaires ou paramtriques.
 *
 */

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import jkb.calkul.*;
import jkb.utils.*;
import jkb.geom.*;

public class traceur extends Applet {

  PlanCourbe zoneDessin;

 public void init() {
  setBackground(Color.white);
  setLayout(new BorderLayout());
  zoneDessin=new PlanCourbe();
  add("Center",zoneDessin);
 }

 public void start() { 
  String comstr,nom;
  Double u,x0,y0; 
  int i=1;
  boolean fini=false;
  u=null; x0=null; y0=null;
  comstr=getParameter("un");
  if (comstr!=null && comstr!="") {
   u=new Double(comstr);
   comstr=getParameter("xmin");
   if (comstr!=null && comstr!="") {
       x0 = new Double(comstr);
       comstr=getParameter("xmin");
       if (comstr!=null && comstr!="") {
	  y0 = new Double(comstr);
       }
   }
   if (u!=null && x0!=null && y0!=null) {
     zoneDessin.optionOrtho=false;
     zoneDessin.fenetreOrtho(u.doubleValue(),x0.doubleValue(),y0.doubleValue());
   }
   else 
   if (u!=null)  zoneDessin.fenetreOrthoCentre(u.doubleValue());
  } 
  comstr=getParameter("quadrillage");
  if (comstr!=null && comstr.equals("non")) zoneDessin.optQuadrillage=false;
  comstr=getParameter("mobile");
  if (comstr!=null && comstr.equals("non")) zoneDessin.optMobile=false;
  do {
   nom="courbe"+i;
   comstr=getParameter(nom);
   if (comstr!=null && comstr.length()>0) zoneDessin.ajouteCourbe(comstr);
   else fini=true;
   i++;
  } while (!fini); 
 }  

 public void efface() {
  zoneDessin.effaceTout();
  zoneDessin.repaint();
 }
 
 public void ajoute(String S) {
  zoneDessin.ajouteCourbe(S);
  zoneDessin.repaint();
 }

 public void ajoute(String S, String couleur) {
  zoneDessin.ajouteCourbe(S,couleur);
  zoneDessin.repaint();
 }
 
 public void trace(String S) {
  zoneDessin.effaceTout();
  zoneDessin.ajouteCourbe(S);
  zoneDessin.repaint();
 }

 public void trace(String S, String couleur) {
  zoneDessin.effaceTout();
  zoneDessin.ajouteCourbe(S,couleur);
  zoneDessin.repaint();
 }

 public void zoom(double d) {
  double u=1/(d*zoneDessin.unPixelX());
  double x0=d*zoneDessin.xMin();
  double y0=d*zoneDessin.yMin();
  zoneDessin.fenetreOrtho(u,x0,y0);
  zoneDessin.repaint();
 }
}

