/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * yfx.java
 * JDK 1.1  
 * Version 1.1 Rvision 03/06/2000
 * Applet permettant de tracer des courbes y=f(x)
 *
 */

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import jkb.calkul.*;
import jkb.utils.*;
import jkb.geom.*;

public class yfx extends Applet 
 implements ActionListener,KeyListener {
 PlanCourbe zoneDessin;
 TextField zoneTexte;
 TextField xmini;
 TextField xmaxi;
 TextField xgradu;
 TextField ymini;
 TextField ymaxi;
 TextField ygradu;
 
 public void init() {
  Panel pan,pan2;
  Label lab;
  setBackground(Color.darkGray);
  setLayout(new BorderLayout(2,2));
  setFont(new Font("SansSerif",Font.PLAIN,10));
  pan=new Panel();
  pan.setBackground(Color.lightGray);
  pan.setLayout(new BorderLayout(5,5));
  pan2=dopanrepere();
  pan.add("North",pan2);
  pan2=new Panel();
  pan2.setBackground(Color.lightGray);
  pan2.setLayout(new FlowLayout());
  Button bouton=new Button("Tracer");
  bouton.addActionListener(this);
  pan2.add(bouton);
  bouton=new Button("Ajouter");
  bouton.addActionListener(this);
  pan2.add(bouton);
  pan.add("South",pan2);
  add("West",pan);
  zoneDessin=new PlanCourbe();
  zoneDessin.optionOrtho=false;
  zoneDessin.fenetre(-10,10,-10,10);
  zoneDessin.optMobile = false;
  add("Center",zoneDessin);
 }
 
 Panel dopanrepere() {
  Panel p=new Panel();
  p.setLayout(new BorderLayout(2,2));
  Label lab=new Label("Repre");
  lab.setFont(new Font("Helvetica",Font.BOLD,12));
  p.add("North",lab);
  Panel pan2=new Panel();
  pan2.setLayout(new GridLayout(6,2,2,2));
  pan2.add(new Label("Xmini :"));
  xmini=new TextField("-10",5);
  pan2.add(xmini);
  pan2.add(new Label("Xmaxi :"));
  xmaxi=new TextField("10",5);
  pan2.add(xmaxi);
  pan2.add(new Label("Xgrad :"));
  xgradu=new TextField("1",5);
  pan2.add(xgradu);
  pan2.add(new Label("Ymini :"));
  ymini=new TextField("-10",5);
  pan2.add(ymini);
  pan2.add(new Label("Ymaxi :"));
  ymaxi=new TextField("10",5);
  pan2.add(ymaxi);
  pan2.add(new Label("Ygrad :"));
  ygradu=new TextField("1",5);
  pan2.add(ygradu);
  p.add("Center",pan2);
  pan2=dopanfonc();
  p.add("South",pan2);
  return p;
 }
 
 Panel dopanfonc() {
  Panel p=new Panel();
  p.setLayout(new BorderLayout(2,2));
  Label lab=new Label("Fonctions");
  lab.setFont(new Font("Helvetica",Font.BOLD,12));
  p.add("North",lab);
  Panel p2=new Panel();
  p2.setLayout(new FlowLayout(FlowLayout.LEFT));
  p2.add(new Label("y=")); 
  zoneTexte=new TextField(15);
  zoneTexte.addKeyListener(this);
  p2.add(zoneTexte);
  p.add("South",p2);
  return p;
 }
 
 double lireValeur(TextField tf) {
  String S=tf.getText();
  Double D=new Double(S);
  return D.doubleValue();
 }
 
 public void lireGradu() {
  zoneDessin.fenetre(lireValeur(xmini),lireValeur(xmaxi),
     lireValeur(ymini),lireValeur(ymaxi)); 
  zoneDessin.xGrad=lireValeur(xgradu);
  zoneDessin.yGrad=lireValeur(ygradu);
 }
 
 public void tracer(boolean enplus) {
  lireGradu();
  String S=zoneTexte.getText();
  if (!enplus) zoneDessin.effaceTout();
  zoneDessin.ajouteCourbe("Y="+S);
  zoneDessin.repaint();
  //Div.bip();
 }
 
 
 public void actionPerformed(ActionEvent evt) {
  if (evt.getActionCommand().equals("Tracer")) tracer(false);
  else if (evt.getActionCommand().equals("Ajouter")) tracer(true);
 }

 public void keyPressed(KeyEvent evt) {
  if (evt.getKeyCode()==KeyEvent.VK_ENTER) tracer(true);
 }
 
 public void keyTyped(KeyEvent evt) {
 }
 
 public void keyReleased(KeyEvent evt) {
 }

 public Insets getInsets() {
  int Bord=2;
  return new Insets(Bord,Bord,Bord,Bord);
 }

 public void start() {
  zoneTexte.requestFocus();
 } 
 
} 

